#include "mdh2bin.h"
main(int argc,char **argv)
{
	FILE *fd=fopen(argv[1],"r");
	char buf[1024];
	float parts[2];
	int faces[3];
	int vertex=0;
	int i,n;
	int ret;

	if (fd) 
	{
		fread(buf,4,1,fd);
		if (memcmp(buf,MDH_MAGIC,4))
		{
			printf("magic: WRONG\n");
			exit(1);
		}
		while(!feof(fd))
		{
			ret=fread(buf,1,1,fd);
			if (ret<=0) break;
			if (buf[0]<MDH_DINAMIC) {
				fread(&n,sizeof(int),1,fd);
				n=ntohl(n);
			}
			switch(buf[0])
			{
			case MDH_NUMFRAMES:
				printf("\n&NUMFRAMES %d\n",n);
				break;
			case MDH_NUMANIMATIONS:
				printf("\n&NUMANIMATIONS %d\n",n);
				break;
			case MDH_SPEED:
				printf("\n&SPEED %d\n",n);
				break;
			case MDH_TEXTURE:
				fread(buf,n,1,fd);
				printf("\n&TEXTURE %s\n",buf);
				break;
			case MDH_VERTEX:
				printf("\n&VERTEX %d\n",n);
				vertex=n;
				break;
			case MDH_FACES:
				printf("\n&FACES %d\n",n);
				for (i=0;i<n;i++)
				{
				fread(&faces,sizeof(int)*3,1,fd);
				printf("%d %d %d\n",ntohl(faces[0]),ntohl(faces[1]),ntohl(faces[2]));
				}
				break;
			case MDH_MAPPARTS:
				printf("\n&MAP_PARTS %d\n",n);
				for (i=0;i<n;i++)
				{
				fread(parts,sizeof(float)*2,1,fd);
				printf("%f %f\n",parts[0],parts[1]);
				}
				break;
			case MDH_MAPFACES:
				printf("\n&MAP_FACES %d\n",n);
				for (i=0;i<n;i++)
				{
				fread(faces,sizeof(int)*3,1,fd);
				printf("%d %d %d\n",ntohl(faces[0]),ntohl(faces[1]),ntohl(faces[2]));
				}
				break;
			case MDH_DINAMIC:
				printf("\n*D\n");
				for (i=0;i<vertex;i++)
				{
				fread(parts,sizeof(float)*3,1,fd);
				printf("%f %f %f\n",parts[0],parts[1],parts[2]);
				}
				break;
			case MDH_NEXTFRAME:
				printf("\n.\n");
				for (i=0;i<vertex;i++)
				{
				fread(parts,sizeof(float)*3,1,fd);
				printf("%f %f %f\n",parts[0],parts[1],parts[2]);
				}
				break;
			case MDH_STATIC:
				printf("\n*\n");
				for (i=0;i<vertex;i++)
				{
				fread(parts,sizeof(float)*3,1,fd);
				printf("%f %f %f\n",parts[0],parts[1],parts[2]);
				}
				break;
			}

		}
		fclose(fd);
	}else printf("err\n"); 
	exit(0);
}
