/*
 * mdh2bin
 *            - pancake@phreaker.net
 *            - http://glh.sourceforge.net
 */

#include "mdh2bin.h"

FILE *fi,*fo;
int i;
int vertex;

void writeData(char w)
{
	int n;
	char b[10];
	char name[1024];

	// WORD
	if (w < MDH_DINAMIC)
	{
		int m;
		fscanf(fi,"%d",&n);
		if (w==MDH_VERTEX) vertex=n;
		b[0]=w; // tag word
		if (w==MDH_TEXTURE) {
			fscanf(fi,"%s",name);
			m=htonl(strlen(name));
			fwrite(b,1,1,fo);
			fwrite(&m,sizeof(int),1,fo);
			fwrite(name,strlen(name),1,fo);
		} else {
			m=htonl(n);
			memcpy(b+1,&m,sizeof(n));
			fwrite(b,sizeof(n)+1,1,fo); // write tag word
		}
	} else {
		b[0]=w;
		fwrite(b,1,1,fo);
	}
	switch(w)
	{
	case MDH_FACES:
	case MDH_MAPFACES:
		while(!feof(fi)&&n)
		{
			int s[3];
			int d[3];
			fscanf(fi,"%d %d %d",&d[0],&d[1],&d[2]);
			for(i=0;i<3;i++)
				s[i]=htonl(d[i]);
			fwrite(s,sizeof(int)*3,1,fo);
			n--;
		}
		if (n) printf("[e] Not enought faces\n");
		break;
	case MDH_MAPPARTS:
		while(!feof(fi)&&n)
		{
			float b[2];
			fscanf(fi,"%f %f",&b[0],&b[1]);
		//	b[0]=htonl(b[0]);
		//	b[1]=htonl(b[1]);

			fwrite(b,sizeof(float)*2,1,fo);
			n--;
		}
		if (n) printf("[e] Not enought parts\n");
		break;
	case MDH_DINAMIC:
	case MDH_STATIC:
		{
			int v=vertex;

			while(!feof(fi)&&v)
			{
				float f[3];
				fscanf(fi,"%f %f %f",&f[0],&f[1],&f[2]);
		//		b[0]=htonl(b[0]);
		//		b[1]=htonl(b[1]);
		//		b[2]=htonl(b[2]);
				fwrite(f,sizeof(float)*3,1,fo);
				v--;
			}
		}
		break;
	case MDH_NEXTFRAME:
		{
		int v=vertex;

		while(!feof(fi)&&v)
			{
			float f[3];
			fscanf(fi,"%f %f %f",&f[0],&f[1],&f[2]);
//			b[0]=htonl(b[0]);
//			b[1]=htonl(b[1]);
//			b[2]=htonl(b[2]);
			fwrite(f,sizeof(float)*3,1,fo);
			v--;
			}
		}
		break;
	case MDH_TEXTURE:
		// look up
		break;
	}
	return;
}

int main(int argc, char *argv[]){
	printf("mdh2bin converter\n");
	
	if (argc<2) {
		printf("Usage: %s [mdhin] [mdhout]\n",argv[0]);
	} else {
	
	char buf[100];
	
	fi=fopen(argv[1],"r");  // input
	fo=fopen(argv[2],"wb"); // output
	if (!fi||!fo) {
		printf("Error fopening files\n");
	} else {
	float *_float;           // float array
	char magic[4]=MDH_MAGIC;
	char *ptr;               // binary acces pointer
	char version[2]=
		{
		MDH_MAJOR_VERSION,
		MDH_MINOR_VERSION
		};

	// Write magic
	fwrite(magic,4,1,fo);
	
	while(!feof(fi))
		{
		buf[0]=0;
		fscanf(fi,"%s",buf);
		if (buf[0]) 
		{
		if (buf[0]=='#') fgets(buf,80,fi); else
		if (buf[0]=='*') (buf[1]=='D')?
			writeData(MDH_DINAMIC):
			writeData(MDH_STATIC); else
		if (buf[0]=='.') 
			writeData(MDH_NEXTFRAME); else
		if (!strcmp(buf,"&NUM_FRAMES"))
			writeData(MDH_NUMFRAMES); else
		if (!strcmp(buf,"&NUM_ANIMATIONS"))
			writeData(MDH_NUMANIMATIONS); else
		if (!strcmp(buf,"&SPEED"))
			writeData(MDH_SPEED); else
		if (!strcmp(buf,"&VERTEX"))
			writeData(MDH_VERTEX); else
		if (!strcmp(buf,"&FACES"))
			writeData(MDH_FACES); else
		if (!strcmp(buf,"&MAP_FACES"))
			writeData(MDH_MAPFACES); else
		if (!strcmp(buf,"&MAP_PARTS"))
			writeData(MDH_MAPPARTS); else
		if (!strcmp(buf,"&TEXTURE"))
			writeData(MDH_TEXTURE);
		else printf("Invalid Keyword (%s)\n",buf);
		}
		}
	fclose(fi);
	fclose(fo);
	printf("Conversion OK\n");
	return 0;
	} } // exit emulator xD

	return 1;
}



