/*
 * mph2bin
 *            - pancake@phreaker.net
 *            - http://glh.sourceforge.net
 */

#include "mph2bin.h"

FILE *fi,*fo;
int i;
int vertex;

void writeData(char w)
{
	int n,m;
	char b[10];
	char name[1024];
	float f[4];
	int d[4];

	// WORD
	if (w < MPH_ELEMENT)
	{
		int m;
		fscanf(fi,"%d",&n);
		b[0]=w; // tag word
		m=htonl(n);
		memcpy(b+1,&m,sizeof(n));
		fwrite(b,sizeof(n)+1,1,fo); // write tag word
	} else {
		b[0]=w;
		fwrite(b,1,1,fo);
	}
	switch(w)
	{
	case MPH_NUMROOMS:
	case MPH_NUMITEMS:
	case MPH_NUMWEAPONS:
	case MPH_MODITEMS:
	case MPH_ROOM:
	case MPH_NUMPORTALS:
	case MPH_HAB:
		break;
	case MPH_PORTAL:
		for(i=0;i<4;i++)
		{
		fscanf(fi,"%f %f %f",&f[0],&f[1],&f[2]);
		fwrite(f,sizeof(float)*3,1,fo);
		}
		break;
	case MPH_TEXTURES: // int(strlen) char*(name_texture)
		for (i=0;i<n;i++)
		{
		fscanf(fi,"%s",name);
		if (strcmp(name,"TEXTURE")) {
			printf("expected TEXTURE\n");
			exit(1);
			}
		fscanf(fi,"%d",&m);
		if (m!=i) {
			printf("expected %d instead of %d",i,m);
			exit(1);
			}
		fscanf(fi,"%s",name);
		m=htonl(strlen(name));
		fwrite(&m,sizeof(int),1,fo);
		fwrite(name,strlen(name),1,fo);
		}
		break;
	case MPH_RATIO:
		fscanf(fi,"%f",&f[0]);
		fwrite(&f[0],sizeof(float),1,fo);
		break;
	case MPH_PVS: //
	case MPH_AUDIO:
		fscanf(fi,"%s",name);
		m=htonl(strlen(name));
		fwrite(&m,sizeof(int),1,fo);
		fwrite(name,strlen(name),1,fo);
		break;
	case MPH_START: // NUM_STARTS
		for (i=0;i<n;i++)
		{
		fscanf(fi,"%s %d",name,&m);
		m=htonl(m);
		fwrite(&m,sizeof(int),1,fo);
		fscanf(fi,"%f %f %f %f",&f[0],&f[1],&f[2],&f[3]);
		fwrite(f,sizeof(float)*4,1,fo);
		}
		break;
	case MPH_NUMVERTEX:
		for(i=0;i<n;i++)
		{
		fscanf(fi,"%f %f %f",&f[0],&f[1],&f[2]);
		fwrite(f,sizeof(float)*3,1,fo);
		}
		break;
	case MPH_NUMFACES:
		for (i=0;i<n;i++)
		{
		fscanf(fi,"%d %d %d %d",&d[0],&d[1],&d[2],&d[3]);
		fwrite(d,sizeof(int)*4,1,fo);
		}
		break;
	case MPH_NUMTEXTVERTEX:
		for (i=0;i<n;i++)
		{
		fscanf(fi,"%f %f",&f[0],&f[1]);
		fwrite(f,sizeof(float)*2,1,fo);
		}
		break;
	case MPH_NUMTEXTFACES:
		for (i=0;i<n;i++)
		{
		fscanf(fi,"%d %d %d",&d[0],&d[1],&d[2]);
		fwrite(d,sizeof(int)*3,1,fo);
		}
		break;
	}
	return;
}

int main(int argc, char *argv[])
{
	char buf[100];

	if (argc<2) {
		printf("Usage: %s [mphin] [binmphout]\n",argv[0]);
	} else {
	
	
	fi=fopen(argv[1],"r");  // input
	fo=fopen(argv[2],"wb"); // output
	if (!fi||!fo) {
		printf("Error fopening files\n");
	} else {
	float *_float;           // float array
	char magic[4]=MPH_MAGIC;
	char *ptr;               // binary acces pointer
	char version[2]=
		{
		MPH_MAJOR_VERSION,
		MPH_MINOR_VERSION
		};
	// Write magic
	fwrite(magic,4,1,fo);
	fwrite(version,2,1,fo);
	
	while(!feof(fi))
		{
		buf[0]=0;
		fscanf(fi,"%s",buf);
		if (buf[0]) 
		{
		if (!strcmp(buf,"NUMERO_HABITACIONES"))
			writeData(MPH_NUMROOMS); else
		if (!strcmp(buf,"NUMERO_ITEMS"))
			writeData(MPH_NUMITEMS); else
		if (!strcmp(buf,"NUMERO_ARMAS"))
			writeData(MPH_NUMWEAPONS); else
		if (!strcmp(buf,"NUMERO_MODELOS_ITEMS"))
			writeData(MPH_NUMITEMS); else
		if (!strcmp(buf,"NUM_TEXTURES"))
			writeData(MPH_TEXTURES); else
		if (!strcmp(buf,"NUM_VERTEX"))
			writeData(MPH_NUMVERTEX); else
		if (!strcmp(buf,"NUM_FACES"))
			writeData(MPH_NUMFACES); else
		if (!strcmp(buf,"NUM_STARTS")) 
			writeData(MPH_START); else
		if (!strcmp(buf,"PVS"))
			writeData(MPH_PVS); else
		if (!strcmp(buf,"AUDIO"))
			writeData(MPH_AUDIO); else
		if (!strcmp(buf,"RATIO"))
			writeData(MPH_RATIO); else
		if (!strcmp(buf,"HABITACION"))
			writeData(MPH_ROOM); else
		if (!strcmp(buf,"NUM_PORTALS"))
			writeData(MPH_NUMPORTALS); else
		if (!strcmp(buf,"ELEMENTO"))
			{
			fscanf(fi,"%s",buf);
			if (!strcmp(buf,"PORTAL"))
				writeData(MPH_PORTAL); else
			if (!strcmp(buf,"HAB"))
				writeData(MPH_HAB); else
				{
				printf("Invalid 'ELEMENTO' type '%s'\n",buf);
				exit(1);
				}
			} else
		if (!strcmp(buf,"NUM_TEXTURE_VERTEX"))
			writeData(MPH_NUMTEXTVERTEX); else
		if (!strcmp(buf,"NUM_TEXTURE_FACES"))
			writeData(MPH_NUMTEXTFACES);
		else printf("Invalid Keyword (%s)\n",buf);
		}
	}
	fclose(fi);
	fclose(fo);
	printf("Conversion OK\n");
	return 0;
	} } // exit emulator xD

	return 1;
}



