#include "AreYouSure.h"

AreYouSure::AreYouSure()
{
	init();
	bg = TGAloader_tid("areyousure.jpg");
	mouse = TGAloader_tid("mouse.png");
	m = new Menu();
	m->addButton(0.4,0.56,0.46,0.625);
	m->addButton(0.512,0.5666,0.58906,0.62229);
	now =0;
}

AreYouSure::~AreYouSure()
{
	TGAloader_untid(bg);
	TGAloader_untid(mouse);
	delete m;
}

void AreYouSure::draw()
{
	if (now+1000 < SDL_GetTicks())
	{
		esc_ok=true;
		now+=999999;
	}
        cursorX=2*(cursorX/WIDTH)-1;
        cursorY=1-(2*(cursorY/HEIGHT));

	/* scene */
	glClearColor(0.0,0.0,0.0,1.0);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	drawImage(bg);

	/* init opengl */
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(90.0,0.0,0.0,500.0);

	/* modelview */
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	
	/* load tecursorXtures */
	glLoadIdentity();

	glEnable(GL_TEXTURE_2D);
	/* cursor */
	glPushMatrix();
	glTranslatef(cursorX,cursorY,-0.1);
	glBindTexture(GL_TEXTURE_2D,mouse);
	glBegin(GL_TRIANGLES);
	glTexCoord2f(0,0);
	glVertex3f(0.0,0.0,-0.1);
	glTexCoord2f(0,1);
	glVertex3f(0.0,-0.05,-0.1);
	glTexCoord2f(1,1);
	glVertex3f(0.05,-0.05,-0.1);
	glEnd();
	glPopMatrix();
}

void AreYouSure::getKeys()
{
	SDL_Event ev;
	Uint8 *keys;
	int x,y;

	SDL_PumpEvents();
	SDL_GetMouseState(&x,&y);
	keys= SDL_GetKeyState(NULL);
	SDL_PollEvent(&ev);
	cursorX=x;
	cursorY=y;

	if (keys[SDLK_y])
	{
		opt = YES;
	} else
	if (keys[SDLK_n])
	{
		opt = NO;
	}

	if (ev.type == SDL_MOUSEBUTTONUP)
	{
		int over = m->isOverItem(x,y);
		if (over != -1)
		{
			switch(over)
			{
			case 0:
				opt = NO;
				break;
			case 1:
				opt = YES;
				break;
			}
		}
	}
}

void AreYouSure::init()
{
	esc_ok=false;
	now = SDL_GetTicks();
	opt = -1;
	cursorX=0;
	cursorY=0;
        // Entire screen
        glViewport(0,0,WIDTH,HEIGHT);
        glScissor(0,0,WIDTH,HEIGHT);

}

bool AreYouSure::isFinished()
{
	return (opt!=-1);
}

bool AreYouSure::isNotSure()
{
	return (opt == NO);
}
