#include "ChooseBody.h"

ChooseBody::ChooseBody()
{
	m = new Menu();
	m->addButton(0.35,0.90,0.65,0.94);

	p=new ParticleSystem("water.pah");
#if 0
	p->setNumberOfParticles(40);
	p->setTTL(50);
	p->setSpeed(0,0.1,  0,0.1,  0,0.1);
	p->setDelay(30);
	p->setGravity(0.01);
	p->setGrowage(0.005);
#endif
	p->start();

	r=new Render();
	e[0]=new Enemy("goblin.car");
	e[0]->setNick("one");
	e[0]->setAnimation(0,0,0);
	e[0]->setPos(GL3f(0,0,0));
	e[0]->setWeapon(new Weapon("pistola.wph"),0);
	e[0]->setRotation(90); // look to 0,0,-100

	e[1]=new Enemy("knight.car");
	e[1]->setNick("two");
	e[1]->setAnimation(0,0,0);
	e[1]->setPos(GL3f(0,0,0));
	e[1]->setRotation(90);

	e[2]=new Enemy("demon.car");
	e[2]->setNick("two");
	e[2]->setAnimation(0,0,0);
	e[2]->setPos(GL3f(0,0,0));
	e[2]->setRotation(90);

	/* hardcoded body names */ // XXX must be patched in the future
	names=(char**)malloc(4*sizeof(char*));
	names[0]=strdup("goblin.car");
	names[1]=strdup("knight.car");
	names[2]=strdup("demon.car");
	names[3]=0;
	scroll=0;
	
	mouse = TGAloader_tid("mouse.png");
	background = TGAloader_tid("choosebody.jpg");

	/* LLUM */
	if (LIGHT)
	{
	glShadeModel(GL_SMOOTH);
	glEnable(GL_LIGHT0);
	glEnable(GL_LIGHTING);

	float difu[]={0.8,0.8,0.8,1};
	glLightfv(GL_LIGHT0,GL_DIFFUSE,difu);
	float ambi[]={0.6,0.6,0.6,1};
	glLightfv(GL_LIGHT0,GL_AMBIENT,ambi);
	float espe[]={0.7,0.7,0.7,1};
	glLightfv(GL_LIGHT0,GL_SPECULAR,espe);
	float pos[]={-0.5,0.5,3,0};
	glLightfv(GL_LIGHT0,GL_POSITION,pos);

#if 0
glEnable(GL_COLOR_MATERIAL);
glColorMaterial(GL_FRONT, GL_AMBIENT_AND_DIFFUSE);
float mdifu[]={0.2,0.2,0.2,1};
   glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, difu);
float mespe[]={0.2,0.2,0.2,1};
   glMaterialfv(GL_FRONT, GL_SPECULAR, espe);
   glMaterialf(GL_FRONT, GL_SHININESS, 0.3);
#endif

	GLfloat amb[]={1.0,1.0,1.0,1};
	glLightModelfv(GL_LIGHT_MODEL_AMBIENT, amb);
	}


	last=SDL_GetTicks();
	option=0;
	esc=false;

	cursorX=0;
	cursorY=0;
	shoot=false;
}

char *ChooseBody::getModel()
{
	return strdup(names[option]);
}

ChooseBody::~ChooseBody()
{
	delete e[0];
	delete e[1];
	delete e[2];
	delete r;
	delete p;

	free(names[0]);
	free(names[1]);	
	free(names[2]);

	free(names);
	TGAloader_untid(background);
	TGAloader_untid(mouse);
	delete m;
}

void ChooseBody::drawScene()
{
	cursorX=2*(cursorX/WIDTH)-1;
	cursorY=1-(2*(cursorY/HEIGHT));

	/* scene */
	glClearColor(0.0,0.0,0.0,1.0);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glColor3f(1,1,1);

	drawImage(background);
	glEnable(GL_LIGHTING);

	/* init opengl */
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(90.0,0.0,0.0,500.0);

	/* modelview */
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(
		0,0,-200,
		0,0,0,
		0,1,0);

	
	/* load textures */
	glLoadIdentity();
	glPolygonMode(GL_FRONT, GL_FILL);
	glEnable(GL_TEXTURE_2D);

p->update();
p->draw(0,1);
//#endif

#define SPACE 0.4
	for(int i=0;names[i];i++)
	{
		float size;
		float order=scroll+SPACE*i;

		if (order>1.4)order=1.4;
		if (order<-1.4)order=-1.4;

		size=(order<0)?-order:order;
		if (size>1.2)size=1;
		if (size<-1.2)size=-1;
		size=1.4-size;
		size*=size;

		glPushMatrix();

		glTranslatef(order,0,-size/2);
		glScalef(size*size,size*size,size);
		//glScalef(size,size,size);
		glTranslatef(0,-0.03,0);

		GLBounding bound=e[i]->getBounding();

		float h=bound.getYmax()-bound.getZmin();
		float w=bound.getXmax()-bound.getXmin();

		r->drawEnemy(e[i]);
		
		e[i]->update(); // animation

		/* draw quad */
#if 0
		glColor3f(0.3*i,0.3*i,1.0);
		glBegin(GL_QUADS);
		glTexCoord2f(1,0);glVertex3f(0.1,0.1,0.0);
		glTexCoord2f(0,0);glVertex3f(-0.1,0.1,0.0);
		glTexCoord2f(0,1);glVertex3f(-0.1,-0.1,0.0);
		glTexCoord2f(1,1);glVertex3f(0.1,-0.1,0.0);
		glEnd();
#endif

		/* check click */
		float shotX=(cursorX); //
		float shotY=(cursorY); //
		float obTOP=(h*size);
		float obBOT=(-h*size);
		float obRIG=(w*size)+order; // translate+scale
		float obLEF=(-w*size)+order; // ""+""

		glLoadIdentity();

		if (DEBUG)
		{
			// DEBUG
			glColor3f(0.0,1.0,0.0);
			glBegin(GL_QUADS);
			glVertex3f(obRIG,obTOP,-size/2);
			glVertex3f(obLEF,obTOP,-size/2);
			glVertex3f(obLEF,obBOT,-size/2);
			glVertex3f(obRIG,obBOT,-size/2);
			glEnd();
			glLoadIdentity();

			glColor3f(0.0,1.0,0.0);
			glBegin(GL_TRIANGLES);
			glVertex3f(shotX+0.1,shotY+0.1,0);
			glVertex3f(shotX,shotY,0);
			glVertex3f(shotX+0.1,shotY,0);
			glEnd();
		}

		if (
		shotX>obLEF &&
		shotX<obRIG &&
		shotY>obBOT &&
		shotY<obTOP )
		{
			if (shoot) {
			printf("CLICKED %d\n",i);
			esc=1;
			option=i;
			} else {
				//e[0]->setAnimation(0,RUNNING_FORWARD,2);
			e[0]->setAnimation(0,0,0);
			}
		} else {
			e[0]->setAnimation(0,0,0);
		}

		glPopMatrix();
	}

	/* selector */
	//glDisable(GL_TEXTURE_2D);
#if 0
	// left row
	glBegin(GL_TRIANGLES);
		glColor3f(0.3,0.3,0.3);
		//glTexCoord2f(.2,.2);
		glVertex3f(-0.7,0.1,-0.5);
		//glTexCoord2f(.2,0);
		glVertex3f(-0.8,0.0,-0.5);
		//glTexCoord2f(0,.2);
		glVertex3f(-0.7,-0.1,-0.5);
	glEnd();

	// right row
	glBegin(GL_TRIANGLES);
		glColor3f(0.3,0.3,0.3);
		//glTexCoord2f(.2,.2);
		glVertex3f(0.7,0.1,-0.5);
		//glTexCoord2f(.2,0);
		glVertex3f(0.7,-0.1,-0.5);
		//glTexCoord2f(0,.2);
		glVertex3f(0.8,0.0,-0.5);
	glEnd();
#endif

	/* light follows cursor position */
	glLoadIdentity();
	float pos[]={cursorX*2,cursorY*2,3};
	glLightfv(GL_LIGHT0,GL_POSITION,pos);

	/* cursor */
	glPushMatrix();
	glTranslatef( cursorX,cursorY,-1);
	glBindTexture(GL_TEXTURE_2D,mouse);
	glBegin(GL_TRIANGLES);
		glTexCoord2f(0,0);
		glVertex3f(0.0,0.0,0.0);
		glTexCoord2f(0,1);
		glVertex3f(0.0,-0.05,0.0);
		glTexCoord2f(1,1);
		glVertex3f(0.05,-0.05,0.0);
	glEnd();
	glPopMatrix();

	shoot=false;
}

void ChooseBody::setOption(int n)
{
	unsigned int now=SDL_GetTicks();

#define MENU_LAST 3
	if (now>last)
	{
		option=n;
		last=now+200;
		if (option<0) option=MENU_LAST-1;
		if (option==MENU_LAST) option=0;
	}
}

void ChooseBody::getKeys()
{
	Uint8 *keys;
	int x,y,s;
	SDL_Event ev;

	/* fetch user events */
	SDL_PumpEvents();
	SDL_GetMouseState(&x,&y);
	keys=SDL_GetKeyState(NULL);
	SDL_PollEvent(&ev);

	if (	ev.type==SDL_MOUSEBUTTONUP ||
		keys[SDLK_RETURN] )
	{
		shoot=true;

		int over = m->isOverItem(x,y);
		if (over != -1)
		{
			esc = 1;
			option=BODY_EXIT;
		}
	}


	cursorX=x;
	cursorY=y;

	if (scroll<-1.8) scroll=-1.8;
	if (scroll>1.0) scroll=1.0;

	s=(100*x/WIDTH)-50;

	if ( s<-5 )
		scroll-=(0.0001)*s;
	if ( s>+5 )
		scroll-=(0.0001)*s;

	if (keys[SDLK_ESCAPE])
	{
		esc=1;
		option=BODY_EXIT;
	}
	if (keys[SDLK_LEFT])
	{
		setOption(option-1);
		scroll=-SPACE*option;
		SDL_WarpMouse(WIDTH/2,HEIGHT/2);
	}
	if (keys[SDLK_RIGHT])
	{
		setOption(option+1);
		scroll=-SPACE*option;
		SDL_WarpMouse(WIDTH/2,HEIGHT/2);
	}
}

bool ChooseBody::isFinished()
{
	return esc;
}

int ChooseBody::getOption()
{
	return option;
}

