#include "Collision.h"

/* TODO : integrate with ControlsKeyboard */
/* TODO : implement gravity */

int DEBUG_COLLISION=0;

Collision::Collision(Stage *stg)
{
	this->stg=stg;
	this->init=false;
	this->ticks=0;
}

Collision::~Collision()
{
}

bool Collision::checkMovement(Orientation *ori, Movement *mov)
{
	bool jam=false;
	float dist,rest;
	float xa,ya,za;

#if 0
	if (mov->pos == 0)
	{
		/* no movement */
		return true;
	}
#endif

	GL3f pos = stg->getCamaraPos();
	x=pos.x;
	y=pos.y+0.2;
	z=pos.z;
	GL3f nex = pos + mov->pos;

	GLFace *face;
	register int i;

if (y<0.21)
{
	mov->pos.y=0;
	return true;
}

return false;

#ifndef FLT_EPSILON // maibe 1? :)
#define FLT_EPSILON 1.19209290e-07F
#endif
#define RTOD (180/PI)

	for(i=0; (face=stg->mapa->getCollision(i)) ; i++)
	{
		GL3f n = face->normal();
		float d=-n.x*face->a.x 
			-n.y*face->a.y
			-n.z*face->a.z;
		float denom=
			n.x*(x-nex.x) +
			n.y*(y-nex.y) +
			n.z*(z-nex.z);

		if (fabsf(denom) > FLT_EPSILON) // line and plane intersects
		{
			float mu;
			GL3f p;
			mu  = -(d+ n.x*x + n.y*y + n.z*z)/denom;
			p.x = x+mu*(nex.x-x);
			p.y = y+mu*(nex.y-y);
			p.z = z+mu*(nex.z-z);
			if (mu>0 && mu<1) /* intersect inside the segment */
			{
				GL3f pa1,pa2,pa3;
				float a1,a2,a3,total;
				/* check if point inside the face */
				pa1=GL3f(face->a.x-p.x, face->a.y-p.y, face->a.z-p.z).normalize();
				pa2=GL3f(face->b.x-p.x, face->b.y-p.y, face->b.z-p.z).normalize();
				pa3=GL3f(face->c.x-p.x, face->c.y-p.y, face->c.z-p.z).normalize();
				/* foo bar */
				a1 = pa1.x*pa2.x + pa1.y*pa2.y + pa1.z*pa2.z;
				a2 = pa2.x*pa3.x + pa2.y*pa3.y + pa2.z*pa3.z;
				a3 = pa3.x*pa1.x + pa3.y*pa1.y + pa3.z*pa1.z;
				total = ( acos(a1) + acos(a2) + acos(a3) ) * RTOD;
				if (fabsf(total-360)<FLT_EPSILON)
				{
				jam=true;
GL3f p;
dist = PointPlaneDistance(pos,face,&p);
rest = mov->pos.size()-dist;
//printf("DIST: %f\n",dist);
/* xyz angles */
xa = AngleBetweenVectors(GL3f(0,mov->pos.y,mov->pos.z),GL3f(0,n.y,n.z));
ya = AngleBetweenVectors(GL3f(mov->pos.x,0,mov->pos.z),GL3f(n.x,0,n.z));
za = AngleBetweenVectors(GL3f(mov->pos.x,mov->pos.y,0),GL3f(n.x,n.y,0));
//printf("ANGLES: %f %f %f\n",cosf(xa),cosf(ya),cosf(za));
//printf("SOBRA: %f\n",rest);
//printf("==>  %f <==\n",sinf(AngleBetweenVectors(GL3f(1,1,0),GL3f(0,1,1))) );//*(M_PI*90));
				delete(face);
				break;
				}
			}
		}
		delete(face);
	}

	if (jam)
	{
	//mov->pos.x+=dist*sinf(ya);
	//	mov->pos.y+=dist;
mov->pos.y=0;
	//mov->pos.y+=rest*sinf(ya);
	//mov->pos.y+=rest*cosf(ya);
	//mov->pos.z-=rest*cosf(ya);

#if 0
// X
mov->pos.z-=rest*cosf(xa);
mov->pos.y+=rest*sinf(xa);

// Y
mov->pos.x+=rest*cosf(ya);
mov->pos.z+=rest*sinf(ya);

// Z
mov->pos.x+=rest*cosf(za);
mov->pos.y+=rest*sinf(za);
#endif

		//mov->pos.y-=rest*cosf(xa);
		//mov->pos.z+=rest*sinf(xa);
		//stg->setCamaraPos(GL3f(x,y+0.05,z));
		printf("JAM!!\n");
	}

	/* update */
	x=pos.x;
	y=pos.y;
	z=pos.z;

	return jam;
}

/*
 * checks if a collision has occurred and moves to the correct new position.
 * (GL3f)  (pos)   :: current position : stg->getCamaraPos();
 * (float) (x,y,z) :: last position    : from last pos.
 */
void Collision::checkIt()
{

	return;

	bool jam=false;

	GL3f pos=stg->getCamaraPos();

	/* first loop */
	if (init==false)
	{
		x=pos.x;
		y=pos.y;
		z=pos.z;
		init=true;
		ticks=SDL_GetTicks()+100;
		return;
	} 

	/* check timeout */
	if (1)//SDL_GetTicks()>ticks)
	{
	ticks=SDL_GetTicks()+50;

	/* CHECK COLLISION */
	//printf("CHECK %f %f %f  -> %f %f %f\n",x,y,z, pos.x, pos.y, pos.z);

	GLFace *face;
	register int i;

#ifndef FLT_EPSILON // maibe 1? :)
#define FLT_EPSILON 1.19209290e-07F
#endif
#define RTOD (180/PI)

	for(i=0; (face=stg->mapa->getCollision(i)) ; i++)
	{
		GL3f n = face->normal();
		float d=-n.x*face->a.x 
			-n.y*face->a.y
			-n.z*face->a.z;
		float denom=
			n.x*(x-pos.x) +
			n.y*(y-pos.y) +
			n.z*(z-pos.z);
#if 0
GL3f tri[3]=
{
	GL3f(face->a.x,face->a.y,face->a.z),
	GL3f(face->b.x,face->b.y,face->b.z),
	GL3f(face->c.x,face->c.y,face->c.z)
};
GL3f line[2]=
{
	GL3f(x,y,z),
	GL3f(pos.x,pos.y,pos.z)
};
if (IntersectedPlane(tri,line))
	{
	printf("AOC: %f\n",AngleBetweenVectors(n, GL3f(n.x,n.y,n.z) ));
	printf("INTERSECTION DETECTED!!!\n");
	jam=true;
	}
#else
		if (fabsf(denom) > FLT_EPSILON) // line and plane intersects
		{
			float mu;
			GL3f p;
			mu  = -(d+ n.x*x + n.y*y + n.z*z)/denom;
			p.x = x+mu*(pos.x-x);
			p.y = y+mu*(pos.y-y);
			p.z = z+mu*(pos.z-z);
			if (mu>0 && mu<1) /* intersect inside the segment */
			{
				GL3f pa1,pa2,pa3;
				float a1,a2,a3,total;
				/* check if point inside the face */
				pa1=GL3f(face->a.x-p.x, face->a.y-p.y, face->a.z-p.z).normalize();
				pa2=GL3f(face->b.x-p.x, face->b.y-p.y, face->b.z-p.z).normalize();
				pa3=GL3f(face->c.x-p.x, face->c.y-p.y, face->c.z-p.z).normalize();
				/* foo bar */
				a1 = pa1.x*pa2.x + pa1.y*pa2.y + pa1.z*pa2.z;
				a2 = pa2.x*pa3.x + pa2.y*pa3.y + pa2.z*pa3.z;
				a3 = pa3.x*pa1.x + pa3.y*pa1.y + pa3.z*pa1.z;
				total = ( acos(a1) + acos(a2) + acos(a3) ) * RTOD;
				if (fabsf(total-360)<1)//FLT_EPSILON)
				{
				jam=true;
				delete(face);
				break;
				}
			}
		}
		delete(face);
#endif
	}

	if (jam)
	{
		stg->setCamaraPos(GL3f(x,y+0.05,z));
		printf("JAM!!\n");
	}

	/* update */
	x=pos.x;
	y=pos.y;
	z=pos.z;

	}
}
