#include "Console.h"

Console::Console (Networkh *net, Message *msg)
{
	this->net = net;
	this->msg = msg;
}

/*!
 *  Parses the string, if it's a command, executes and sends it to the server;
 *  if it's a plane phrase, only sends it to the server.
 *  
 *  \sa COMMAND_CHAR, execCommand()
 */
void Console::parseCommand (const char *str)
{
	char txt[1024];

	strcpy(txt,"msg: ");
	strcat(txt,str);
	msg->addMessage(txt);

	if (str[0] == COMMAND_CHAR)
		execCommand(str+1);

	if (NETWORK)
	{
		fprintf(stderr,str);
		net->cli_sendTalk(str);
	}
}

void Console::execCommand (const char *cmd)
{
	int cmdLen = strlen(cmd);
	char cmdU[cmdLen];
	
	for(int i=0; i<=cmdLen; i++)
		cmdU[i]=toupper(cmd[i]);

	// TODO Should make a lookup table
	// TODO Reuse functions, as in the case of ControlsKeyboard::f_quit
	if (!strcmp(cmdU,"QUIT")) {
		killProgram(1);
	} else {
		char buf[1024];
		strcpy(buf,"unknown command: ");
		strcat(buf,cmdU);
		msg->addMessage(buf);
	}
}

