#ifndef _CONSOLE_H_
#define _CONSOLE_H_

/*! \file  Console.h
 *  \brief Console class declaration
 */

#include <ctype.h>
#include <string.h>

#include "Message.h"
#include "Networkh.h"

extern void killProgram(int mode);

//! Prefix to specify a command
#define COMMAND_CHAR '.'

//! Console controller
/*! This class controls the console and parses its commands */
class Console
{
public:
	//! Console constructor
	Console (Networkh *net, Message *msg);

	//! Parses the string to look for a command
	void parseCommand (const char *str);
	//! Executes a command line
	void execCommand (const char *cmd);

private:
	Networkh *net;
	Message  *msg;
};

#endif

