#ifndef _CONTROLS_H_
#define _CONTROLS_H_

/*! \file  Controls.h
 *  \brief Controls class declaration
 */

#include <SDL/SDL.h>

#include "ControlsMouse.h"
#include "ControlsKeyboard.h"
#include "Collision.h"
#include "Camera.h"
#include "Networkh.h"

//! Input devices controller
/*! This class controls the inputs from all available devices. */
class Controls 
{
public:
	//! Controls contructor
	Controls (Camera *cam, Stage *stg, Collision *col, Networkh *net);
	//! Controls destructor
	~Controls ();
	//! Grabs the input from all the devices
	void input ();
	bool finished;

private:
	ControlsMouse    *ctrlMs;
	ControlsKeyboard *ctrlKb;
};

#endif

