#ifndef _CONTROLSMOUSE_H_
#define _CONTROLSMOUSE_H_

/*! \file  ControlsMouse.h
 *  \brief ControlsMouse class declaration
 */

#if WIN32
#include <windows.h>
#endif

#include <math.h>

#include "Camera.h"

//! Default mouse speed on the X axis
#define MOUSE_SPEED_X 0.06f;
//! Default mouse speed on the Y axis
#define MOUSE_SPEED_Y 0.09f;

//! Mouse device controller
/*! This class controls the inputs from a mouse. */
class ControlsMouse
{
public:
	//! ControlsMouse constructor
	ControlsMouse (Camera *cam);
	//! ControlsMouse destructor
	~ControlsMouse ();
	//! Grabs the input from the mouse
	void input();

private:
	Camera *cam;

	//! \var mouse_speed_x Actual mouse speed on the X axis
	//! \var mouse_speed_y Actual mouse speed on the Y axis
	float mouse_speed_x,
	      mouse_speed_y;
};

#endif

