#include <stdlib.h>
#include "Dirs.h"

bool checkDataDir()
{
#if WIN32
	// TODO win32 stuff
#else
	struct stat mydir;
	int ret;

	ret = stat(getDataDir(),&mydir) ;
	if (ret) return false;

	if (!S_ISDIR(mydir.st_mode))
		return false;
#endif
	return true;
}

char *datadir=0;
char * getDataDir()
{
#if WIN32
	if (datadir==NULL)
	{
	#define BUFSIZE 1024
	TCHAR Buffer[BUFSIZE];
	DWORD dwRet;
	dwRet=GetCurrentDirectory(BUFSIZE,Buffer);
	datadir=strdup(Buffer);
	}
#endif
	if (datadir)
		return datadir;
	return GLHDATADIR;
}

void setDataDir(char *str)
{
	if (datadir)
		free(datadir);
	datadir=strdup(str);
}

void chCfgDir()
{
	#if !WIN32
	char *home=getenv("HOME");
	if (home)
	{
		chdir(home);
		mkdir(".glH",DIRPERM);
		chdir(".glH"); // default cfgfiles dir
	}
	#endif
}


char * getDirs(char *str)
{
	int i;

	typedef struct 
	{
	char *ext;
	char *dir;
	} DirNames; 

	DirNames dn[]=
	{ 
	{"mph","data/maps"},
	{"mdh","data/modl"},
	{"tg2","data/text"},
	{"tga","data/text"},
	{"png","data/text"},
	{"jpg","data/text"},
	{"rph","data/role"},
	{"ith","data/item"},
	{"pah","data/item"},
	{"wph","data/weap"},
	{"pvs","data/maps"},
	{"car","data/cars"},
	{"skh","data/skyh"},
	{"auh","data/maps"},
	{"wav","data/soun"},
	{"ogg","data/soun"},
	{0,0}
	};

#if WIN32
	#define BUFSIZE 1024
	TCHAR Buffer[BUFSIZE];
	DWORD dwRet;
	dwRet=GetCurrentDirectory(BUFSIZE,Buffer);
#endif

	chdir(getDataDir()); // XXX guarrada padre

	for (i=0;dn[i].ext!=0;i++)
	{
	if ( !strcmp(dn[i].ext,str+strlen(str)-3) )
		{
		return dn[i].dir;
		}
	}

	printf("Unknown extension for file: %s\n",str);

	return "data/unkn";
}

char * makeDirs(char *str)
{
	char *dir;
	
	if (mkdir("data",DIRPERM))
	{
#if WIN32
	// TODO win32 stuff
#else
		if (errno!=EEXIST)
			throw 1;
#endif
	}

	dir=getDirs(str);
	mkdir(dir,DIRPERM);

	return dir;
}
