#ifndef _DIRS_H_
#define _DIRS_H_

#if WIN32
   #include <windows.h>
   #include <direct.h>
   #define mkdir(str,str2) mkdir(str)
#else
   #include <unistd.h>
   #include <sys/stat.h>
   #include <sys/types.h>
   #include <errno.h>
#endif
   #include <stdio.h>
   #include <string.h>

#ifndef PREFIX
#define PREFIX "/usr/local"
#endif

#define DIRPERM S_IEXEC|S_IRUSR|S_IWUSR|S_IRGRP|S_IROTH

#if WIN32
#define GLHDATADIR "."
#else
#ifndef GLHDATADIR
#define GLHDATADIR PREFIX"/share/glh/"
#endif
#endif

bool checkDataDir();
void chCfgDir();            // chdir to config dir
void setDataDir(char *str); // set default data directory
char * getDataDir();        // get default data directory
char * makeDirs(char *str); // make directories needed for this filename
char * getDirs(char *str);  // return the directory name for this kind of file.

#endif 


