#ifndef _INCLUDE_LIGHT_H_
#define _INCLUDE_LIGHT_H_

#include "OpenGLH.h"

class Light
{
private:
	/* opengl only supports 8 lights */
	bool lights[8];
	float pos[8*3];

	bool checkLid(int lid);

public:
	Light();
	~Light();

	int  add(); /* -1 max lights or LightID */
	void del(int lid);

	void setPosition(int lid, XYZ);
	void setPosition(int lid, GL3f xyz);
	void setDirection(int lid, XYZ);
	void setCutOff(int lid, float value);

	void update(GL3f xyz,float yaw);

	void setAmbient(int lid, RGBA);
	void setDiffuse(int lid, RGBA);
	void setSpecular(int lid, RGBA);

	void enable(int lid);
	void disable(int lid);

	void enable();
	void disable();

	void flat();
	void smooth();

	void setAmbient(RGBA);
};

#endif
