#include "Message.h"
#include <ctype.h>

Message::Message(float y)
{
	fuente = new Text2D("font.png");
	y_orig = y;
	n = 0;
	talkMessageActive = false;
	talkMessageActive2= false;
	talkMessage[0]=0;
	talkMessagePos=0;
}

Message::~Message()
{
	printf("[<] Message Control\n");
	delete fuente;
}

void Message::addMessage(char *messageStr)
{
	/* if matches maxmessages drop the first one */
	if (n==MAX_MESSAGES)
	{
		messageArray[0].time_left=0;
		killMessages();
	}

	printf("[i]: %s\n",messageStr);

	/* add message to array */
	messageArray[n++]=message(messageStr);
}

void Message::drawMessages()
{
	int j;

	//Destruimos los mensajes que han caducado
	killMessages();
	
	//Pintamos los mensajes
	for (j=0;j<n;j++)
	{
		glEnter2D(WIDTH,HEIGHT);
		fuente->print(
			messageArray[j].msg,
			MESSAGE_X_ORIG,
			(y_orig+(j*SPACE_BETWEEN_MESSAGES)),
			11.0f);

		glExit2D();
	}

	//Comprobamos si estamos en el modo "say" para escribir mensajes y, en caso afirmativo,
	//pintamos lo que hayamos escrito por pantalla
	if (talkMessageActive)
	{
		glEnter2D(WIDTH,HEIGHT);
		fuente->print("Say: ",MESSAGE_X_ORIG+120,480-TALK_MESSAGE_Y,1.0f,1.0f,1.0f,10.0f);
		fuente->print(talkMessage,MESSAGE_X_ORIG+180,480-TALK_MESSAGE_Y,1.0f,1.0f,1.0f,10.0f);
		glExit2D();
	}
}

/*
** Remove outdated messages
*/
void Message::killMessages()
{
	for(int i=0;i<n;i++)
	{
		//Miramos si el mensaje que ocupa actualmente la posicion 0 ha caducado,
		//si es asi, lo eliminamos bajando todos los mensajes una posicion y volvemos
		//a comprobarlo. 
		//Si no ha caducado salimos del bucle
		if(messageArray[0].time_left<SDL_GetTicks())
		{
			strcpy(messageArray[0].msg,"");
			for (int j=0;j<n-1;j++)
			{
				messageArray[j]=message(messageArray[j+1]);
			}
			n--;
		}
		else break;
	}
}


bool Message::isTalkMessageActive()
{
	bool ret=false;

	if (talkMessageActive)
	{
		if (talkMessageActive2==false)
		{
			ret=false;
			talkMessageActive2=true;
		} else  ret=true;
	}
	return ret;
}

void Message::destroyTalkMessage()
{
	talkMessageActive=false;
	talkMessageActive2=false;
	talkMessage[0]=0;
}

void Message::createTalkMessage()
{
	talkMessageActive=true;
	talkMessagePos=0;
	talkMessage[talkMessagePos]='\0';
}

void Message::addToTalkMessage(char c)
{
	if (talkMessagePos < MAX_MESSAGE_LENGTH)
	{
		talkMessage[talkMessagePos]=c; //fuente->translate((int)c);
		talkMessagePos++;
		talkMessage[talkMessagePos]='\0';
	}
}

void Message::commitTalkMessage()
{
	addMessage(talkMessage);
	destroyTalkMessage();
}

void Message::delFromTalkMessage(int num)
{
	if (talkMessagePos - num >= 0)
	{
		talkMessagePos -= num;
		talkMessage[talkMessagePos]='\0';
	}
}

const char * Message::getMessage()
{
	return strdup(talkMessage);
}

/*
void Message::translate(int num, char* letras)
{
	fuente->translate(num, letras);
}
*/
