#ifndef _MESSAGECONTROL_H_
#define _MESSAGECONTROL_H_

#if WIN32
#include <windows.h>
#endif

#include <time.h>
#include <string.h>
#include <stdio.h>
#include "define.h"
#include "OpenGLH.h"
#include <SDL/SDL.h>
#include "Text2D.h"

//Struct to load a message
struct message
{
	char msg[MAX_MESSAGE_LENGTH];
	unsigned int time_left;

	message(){
		time_left=0;
	}

	~message(){}

	message(char *da_msg)
	{
		strcpy(msg,da_msg);
		time_left=SDL_GetTicks()+MESSAGE_TIME_LEFT;
	}

	message(const message &da_msg)
	{
		strcpy(msg, da_msg.msg);
		time_left=da_msg.time_left;
	}

	message& operator=(const message da_msg) 
	{
		strcpy(msg,da_msg.msg);
		time_left=da_msg.time_left;
		return *this;
	}

};

/* TextMsg control */
class Message
{
	int n; /* Number of messages */
	float y_orig; /* The y original component */
	message messageArray[MAX_MESSAGES]; /* messages array */
	bool talkMessageActive; /* to type or not to type */
	bool talkMessageActive2; // simple hack for dup keys
	char talkMessage[MAX_MESSAGE_LENGTH]; /* ptr to the current msg */
	int talkMessagePos;
	Text2D *fuente;
	
private:
	void killMessages(); /* cleanup all outdated messages */

public:
	Message(float); /* y pos */
	~Message();
	void addMessage(char *message);
	void drawMessages();
	bool isTalkMessageActive(); //true if writting mode
	void destroyTalkMessage();  //back to no-writting mode
	void createTalkMessage();  //Enters in the talk state
	void addToTalkMessage(char c);
	void delFromTalkMessage(int num);
	void commitTalkMessage();
	const char *getMessage();
	/*
	** num: number of letters
	** letras: returns the letters assigned to that number :?
	void translate(int num, char* letras);
	*/
};

#endif

