#ifndef _ORIENTATION_H__
#define _ORIENTATION_H_

/*! \file  Orientation.h
 *  \brief Camera orientation class declaration
 */

#include "OpenGLH.h"

//! Camera orientation
class Orientation
{
public:
	//! Adds a modification on the horizontal axis
	void addH (float f);

	//! Adds a modification on the vertical axis
	void addV (float f);

	float getH ();
	float getV ();

	void setH (float f);
	void setV (float f);

private:
	//! Modification to current orientation
	GL2f ori;
};

#endif
