#ifndef _PARTICLE_SYSTEM_H_
#define _PARTICLE_SYSTEM_H_

#include "Particle.h"
#include "OpenGLH.h"
#include "TGAloader.h"

enum {
        TRIANGLES,
        QUADS,
        LINES
};

class ParticleSystem
{
private:
	int n;
	float grow,size;
	/* color */
	float r,g,b;
	/* position */
	float x,y,z;
	/* speed */
	float vx,vy,vz;
	int rx,ry,rz;
	/* wind */
	float wx,wy,wz;
	int wrx,wry,wrz;
	/* base */
	float w,h;
	float gravity;
	Particle **p;
	unsigned int texture;
	bool running;
	unsigned int ttl;
	unsigned int last, delay;
	int shape;

	void init();

public:
	ParticleSystem();
	ParticleSystem(char*);
	~ParticleSystem();

	void start();
	void stop();
	void update();
	void draw(float,float);

	void setNumberOfParticles(int);
	void setPosition(float x,float y,float z);
	void setDirection(GL3f);
	void setGravity(float force);
	void setGravityDirection(GL3f);
	void setSurfaceWidth(float);
	void setSurfaceHeight(float);
	void setTexture(char *name);
	void setTTL(unsigned int);
	void setDelay(unsigned int);
	void setGrowage(float);
	void setSpeed(float x,float,float y,float,float z,float);
	void setWind(float x,float, float y,float,float z,float);
	void setBase(float w,float h);
	void setSize(float s);
};

#endif
