#ifndef _CARACTER_H_
#define _CARACTER_H_

#include "Properties.h"
#include "define.h"
#include "Weapon.h"

extern void killProgram(int mode);

struct Movement
{
	GL3f pos;
	bool run;
};

//Clase q Propertiesa los personajes en si
class Player
{
private:
	Properties **model;               //Array con las 3 partes del cuerpo q tiene el personaje
	GLBounding bounding;           //El bounding total
	GL3f *bodyUnion;               //Array de los puntos que sirven para unir cuerpo y cabeza
	GL3f *legsUnion;               //Array de los puntos que sirven para unir piernas y cuerpo
	GL3f *weaponUnion;             //Array con la posicion d la arma
	GL2f *weaponAngle;             //Array con el angulo d la arma

	Weapon *arma;				   //Puntero a la arma seleccionada
	int actualAmmo;

	char file[100];
	char nick[100];
	bool isBinaryCarFile(char *);
	void loadBinary(char *);
	void loadPlain(char *);
	float angle;

	int animation;
public:
	Player();                    //Constructor de la clase
	~Player();

	//Le has de pasar el nombre del fichero que almacena el personaje
	void load(char *ruta);
	int getAnimation();
	GL3f getPosition();
	void setPosition(double x, double y, double z);
	void addMovement(Movement &mov);

	//Cojes el bounding total
	GLBounding getBounding();

	//Cojes la posicion
	GL3f getPos();

	//Le das una nueva posicion
	void setPos(GL3f pos);

	//Nueva rotacion
	void setRotation(float angle);

	//Devuelve la rotacion actual
	float getRotation();

	float getBaseAngle();

	//Devuelve el id de la habitacion en la que te encuentras
	int getId();
#if _PVS

	//Le asignas un id al personaje
	void setId(int id_old);
#endif

	//Le asignas una animacion al personaje. Espera un integer con las animaciones 
	//y te devuelve true or false dependiendo de si ha habido algun error o no
	bool setAnimation(int animationHead, int animationBody, int animationLegs);

	//Devuelve el objeto Properties de la posicion que le digas 
	Properties *getControl(int which);

	//Devuelve un punto de union. Le has de pasar un int con la parte del cuerpo que quieres
	//y en que posicion de la animacion est
	GL3f getUnion (int part, int which=-1);

	GL2f getWeaponRot (int which=-1);
	
	//Actualiza las diferentes partes del cuerpo
	void update();

	//Hace o no invisible al personaje
	void setVisible(bool visible);

	//Devuelve un boleano indicando si se ve el objeto o no
	bool isVisible();

	Weapon *getWeapon();

	void setWeapon(Weapon *,int numBalas);

	void killEnemy();

	void reviveEnemy();
	bool haveWeapon();

	bool isDying();

	void setNick(char *nick);

	char *getNick();

};


#endif
