#ifndef _RENDER_H_
#define _RENDER_H_

#if WIN32
#include <windows.h>
#endif

#include <SDL/SDL.h>
#include "OpenGLH.h"
#include "Player.h"
#include "Stage.h"
#include "Mates.h"
#include "Interface.h"

//Clase q pinta todo por pantalla
class Render
{
private:
	bool viewMap;
	int modo; //Definimos las veces q ha de pintar
	float step;
	unsigned int delay,nextChange;

	//Carga la textura q le pidamos
	void setTexture(GLuint textureObj);
	void setTexture(texture textreObj);
	
	//Pinta la camara, o lo q es lo mismo, la coloca donde vamos a mirar
	//Espera un objeto stage
	void drawCamera(Stage *fase);
	
	//Pinta el escenario.
	//Espera un objeto stage y un array de ints con el pvs de lo q ve	
	void pintaEscenario(Stage *fase, int *PVS);
	
	//Pinta items.
	//Espera un objeto stage y un array de ints con el pvs de lo q ve
	void pintaItems(Stage *fase, int *PVS);
	
	//Pinta enemigos
	//Espera un objeto stage y un array de ints con el pvs de lo q ve
	void pintaEnemigos(Stage *fase, int *PVS);


#if _PVS
	//Pinta los portales
	//Espera un objeto stage y un array de ints con el pvs de lo q ve
	void pintaPortales(Stage *fase, int *PVS);
#endif

	//Pinta los boundings de los personajes
	//Espera un objeto stage y un array de ints con el pvs de lo q ve
	void pintaBoundings(Stage *fase, int *PVS);
	
	//Inicializa el vertex array
	//Espera el array de vertices normales y vertices de textura
	void beginVertexArray(float *vertexArray, float *textureArray);
	
	//Desactiva el vertex array
	void endVertexArray();
	
	//Pinta el vertex array
	void drawVertexArray(texture textura, float *normals, int begin, int end, float r=1.0f, float g=1.0f, float b=1.0f, float a=-1);

	//Pinta un objeto sin vertex array
	//Espera una textura, un array de vertices, un array de caras y cuantas caras ha de pintar
	void drawObject(
		GLuint textura,
		float *vertex,
		float *textureVertex,
		int numFaces,
		float r=1.0f, float g=1.0f, float b=1.0f,float a=-1.0f);
	void drawBoundingCube(GLBounding bounding);
	
public:
	//Inicializa todos los parametros para el Renderizado
	Render();
	~Render();

	//Metodo al que le pasas un objeto stage y te pinta el mundo
	void draw(Stage *fase);
	void setWalkEffect(float);
	void setViewMap(bool);
	void drawEnemy(Enemy *e);
};

#endif
