#include "main.h"
//static Fl_PNG_Image *img;

bool ScriptH::Run()
{
	if (wait) return true;
	if (!this->p)
	{
		throw new Error("ProgressBar not defined");
	}
	
	this->buf[0]=0; // clear buffer
	
	fgets(this->buf,this->bufsize,this->fd);
	this->buf[strlen(this->buf)-1]=0;

	// Analize String
	if (!strncmp("#",this->buf,1))       {
		return true;                 }
	else
	if (!strncmp("sleep",this->buf,5))   {
		sleep(atoi(this->buf+6));    }
	else
	if (!strncmp("pg",this->buf,2))      {
		p->value(atoi(this->buf+3)); }
	else
	if (!strncmp("text",this->buf,4))    {
		this->setText(this->buf+5);  }
	else
	if (!strncmp("img", this->buf,3))    {
		this->setImage(this->buf+4); }
	else
	if (!strncmp("cp", this->buf,2))     {
		this->CopyFile(this->buf+3); }
	else
	if (!strncmp("cpd", this->buf,2))    {
		this->CopyDirs(this->buf+4); }
	else
	if (!strncmp("get", this->buf,3))    {
		this->GetString(this->buf+4);}
	else
	if (!strncmp("mkdir",this->buf,5))   {
		this->MakeDirs(this->buf+6); }
	else
	if (!strncmp("exec",this->buf,4))    {
		patchString(this->buf+5);
		this->Exec(this->str);       }
	else
	if (!strncmp("read",this->buf,+4))   {
		this->Read(this->buf+5);     }

	if (feof(fd)) return false;
	return true;
}

ScriptH::ScriptH(char *fn,int bufsize)
{
	this->fd=fopen(fn,"r");
	if (!this->fd)
	{
		throw new Error("Script not found");
	}
	
	this->buf=new char[bufsize];
	if (!this->buf)
	{
		throw new Error("Error on new char[buf]");
	} else {
		this->bufsize=bufsize;
	}
	this->p=NULL;
	this->b=NULL;
	this->i=NULL;
	this->wait=false;
	this->iDone=NULL;
	this->str=NULL;
}

ScriptH::~ScriptH()
{
	if (this->fd)
		fclose(this->fd);
	if (this->buf)
		delete buf;
}

void ScriptH::setText(char *str)
{
	int i=strlen(str);
	if (!this->b) return;
	while(i--) if (str[i]=='\\') str[i]='\n';
	this->b->label(str);
}

void ScriptH::setProgress(Fl_Progress *p)
{
	if (p==NULL) return;
	this->p=p;
}

void ScriptH::setBox(Fl_Box *b)
{
	if (b==NULL) return;
	this->b=b;
}

void ScriptH::setImageBox(Fl_Box *i)
{
	if (i==NULL) return;
	this->i=i;
}

void ScriptH::setImage(char *f)
{
	static Fl_PNG_Image *img;
	if (this->i==NULL) return;
	img=new Fl_PNG_Image(f);
	Fl::redraw();
	this->i->image(img);
	printf("Setting image to <<%s>>\n",f);
}

void ScriptH::CopyFile(char *i)
{
	char buf[1000];
	
	this->patchString(i);
#if WIN32
	sprintf(buf,"copy %s",this->str);
#else
	sprintf(buf,"cp %s",this->str);
#endif
	this->Exec(buf);
}

void ScriptH::Done()
{
	this->setText("Process Done");
	return;
	Fl_Button *b=new Fl_Button(100,20,100,30,"Ok");
		b->box(FL_PLASTIC_UP_BOX);
	//	b->callback((Fl_Callback*)closeDone);

	wDone->end();
	wDone->set_modal();
	wDone->show();
}

void ScriptH::Exec(char *b)
{
	printf("Executing %s\n",b);
#if WIN32
	_spawnlp(_P_WAIT,b,"",NULL);
#else
	system(b);
#endif
}

void InputOk()
{
	scr->InputOk();
}

void ScriptH::InputOk()
{
	this->wDone->hide();
	this->wait=false;
}

void ScriptH::GetString(char *str)
{
	this->wDone=new Fl_Window(350,100,"glhi input");
	this->iDone=new Fl_Input(160,20,150,30,str);
	this->bDone=new Fl_Button(120,60,100,30,"Ok");
		this->bDone->box(FL_PLASTIC_UP_BOX);
		this->bDone->callback((Fl_Callback*)::InputOk);
	this->wDone->set_modal();
	this->wDone->end();
	this->wDone->show();
	this->wait=true;
}

void ScriptH::patchString(char *str)
{
	int i,i2;
	
	if(!this->str)
		this->str=(char *)malloc(1000);
	
	for(i=i2=0;str[i];i++,i2++)
	{
	  if (str[i]=='?')
	  {
	    const char *b=this->iDone->value();
	    memcpy(this->str+i2,b,strlen(b));
	    i2+=strlen(b)-1;
	  } else 
	  #if WIN32
	  if (str[i]=='/') { str[i]='\\'; }
	  #else
	  if (str[i]=='\\') { str[i]='/'; }
	  #endif
	  else {
	    this->str[i2]=str[i];
	  }
	}
	this->str[i2]=0;
	printf("patched: \"%s\"\n",this->str);
}

void ScriptH::CopyDirs(char *i)
{
	char b[1000];
	this->patchString(i);
	
	#if WIN32
	sprintf(b,"xcopy %s /E /C /I /Q /R /Y ",this->str);
	#else
	sprintf(b,"cp -rf %s",this->str);
	#endif

	this->Exec(b);	
}

void ScriptH::Read(char *str)
{
	patchString(str);
	this->wDone=new Fl_Window(350,300,"glhi read");
	this->vDone=new Fl_Help_View(20,20,300,200);
		this->vDone->load(this->str);
	this->bDone=new Fl_Button(120,260,100,30,"Ok");
		this->bDone->box(FL_PLASTIC_UP_BOX);
		this->bDone->callback((Fl_Callback*)::InputOk);
	this->wDone->set_modal();
	this->wDone->end();
	this->wDone->show();
	this->wait=true;
}

void ScriptH::MakeDirs(char *str)
{
	int i,i2;
	char b[1000];

	patchString(str); // returns on this->str;

	#if WIN32
	sprintf(b,"md %s",this->str);
	#else
	sprintf(b,"mkdir -p %s",this->str);
	#endif
	
	this->Exec(b);
}



