#include "main.hh"

Fl_Window *wPlay;
Fl_Input *iLogin,*iPort,*iServer;
Fl_Secret_Input *iPass;

#define BUF 80
typedef struct sPlay{ char login[BUF],pwd[BUF],serv[BUF],port[BUF]; };
sPlay sPlayData;


void play_cancel()
{
	wPlay->hide();
}

void play_save()
{
	FILE *fd;

	fd=fopen("config.cli","w");
	if (!fd) return;
	fprintf(fd,"LOGIN %s\n"\
		   "PASSWORD %s\n"\
		   "SERVER %s\n"\
		   "PORT %s\n\n",
		   checkString(iLogin->value()),
		   checkString(iPass->value()),
		   checkString(iServer->value()),
		   checkString(iPort->value()));
		   
	fclose(fd);
	play_cancel();
}

void play_connect()
{
	play_save();
#ifdef WIN32
	_spawnlp(_P_NOWAIT,"notepad","pop",NULL);
#else
	system("ls");
#endif
}






void play_load()
{
	FILE *fd;
	char buf[BUF];

	memset(&sPlayData,0,sizeof(sPlay));
	
	fd=fopen("config.cli","r");
	if (!fd) return;
	while(!feof(fd))
	{
		buf[0]=0;
		fscanf(fd,"%s",buf);
		if (!strcmp(buf,"LOGIN")) {
			fscanf(fd,"%s",buf);
			strcpy(sPlayData.login,checkInput(buf));
		} else
		if (!strcmp(buf,"PASSWORD")) {
			fscanf(fd,"%s",buf);
			strcpy(sPlayData.pwd,checkInput(buf));
		} else
		if (!strcmp(buf,"SERVER")) {
			fscanf(fd,"%s",buf);
			strcpy(sPlayData.serv,checkInput(buf));
		} else
		if (!strcmp(buf,"PORT")) {
			fscanf(fd,"%s",buf);
			strcpy(sPlayData.port,checkInput(buf));
		}
	}
	fclose(fd);
	if (!sPlayData.serv[0]) strcpy(sPlayData.serv,"localhost");
	if (!sPlayData.port[0]) strcpy(sPlayData.port,"9999");
}

void play()
{
	play_load();
	
	wPlay= new Fl_Window(450,100,"glH - start game");

	iLogin=	new Fl_Input(170,10,145,25,"Login:");
		iLogin->value(sPlayData.login);
	
	iPass=new Fl_Secret_Input(170,38,145,25,"Password:");
		iPass->value(sPlayData.pwd);

	iServer=new Fl_Input(170,68,105,25,"Server (ip|port):");
		iServer->value(sPlayData.serv);

	iPort=new Fl_Input(275,68,40,25);
		iPort->value(sPlayData.port);

	Fl_Return_Button *bConnect=
		new Fl_Return_Button(339,10,105,25,"&Connect");
		bConnect->box(FL_PLASTIC_UP_BOX);
		bConnect->callback((Fl_Callback*)play_connect);
		bConnect->shortcut(FL_Enter);

	Fl_Button *bSave=
		new Fl_Button(339,40,105,25,"Save");
		bSave->box(FL_PLASTIC_DOWN_BOX);
		bSave->down_box(FL_PLASTIC_UP_BOX);        		
		bSave->callback((Fl_Callback*)play_save);

	Fl_Button *bCancel=
		new Fl_Button(339,70,105,25,"Cancel");
		bCancel->box(FL_PLASTIC_DOWN_BOX);
		bCancel->down_box(FL_PLASTIC_UP_BOX);
		bCancel->callback((Fl_Callback*)play_cancel);
	
	wPlay->set_modal();  // per sobre la resta de finestres.
	wPlay->end();
	wPlay->show();
}
