#include "main.hh"

Fl_Window *wSound;
Fl_Dial *bVolume;
Fl_Check_Button *bSoundEnable;

void sound_cancel()
{
	wSound->hide();
}

void sound_load()
{
	char buf[80];
	FILE *fd;

	fd=fopen("config.snd","r");
	if (!fd) return;
	while(!feof(fd))
	{
		buf[0]=0;
		fscanf(fd,"%s",buf);
		if (!strcmp("ENABLE",buf))
		{
			fscanf(fd,"%s",buf);
			(!strcmp("1",buf))?
				bSoundEnable->set():
				bSoundEnable->clear();
		} else
		if (!strcmp("VOLUME",buf))
		{
			fscanf(fd,"%s",buf);
			bVolume->value((double)atoi(buf));
		}
	}
	fclose(fd);
}

void sound_save()
{
	FILE *fd;
	
	fd=fopen("config.snd","w");
	if (!fd) return;
	fprintf(fd,"ENABLE %s\n"\
		   "VOLUME %d\n\n",
		   (bSoundEnable->value())?"1":"0",
		   (int)bVolume->value());
	fclose(fd);
	sound_cancel();
}

void sound()
{
	wSound=new Fl_Window(290,125,"glH - audioconf");

	bSoundEnable=new Fl_Check_Button(44,20,95,25,"Enabled");
		bSoundEnable->down_box(FL_DOWN_BOX);
	
	bVolume=new Fl_Dial(180,15,40,40,"Volume");
		bVolume->minimum(0);
		bVolume->maximum(100);

	Fl_Return_Button *bSave=new Fl_Return_Button(40,85,90,25,"&Save");
		bSave->shortcut(FL_Enter);
		bSave->callback((Fl_Callback*)sound_save);
		bSave->box(FL_PLASTIC_UP_BOX);

	Fl_Button *bCancel=new Fl_Button(170,85,90,25,"&Cancel");
		bCancel->shortcut(FL_Escape);
		bCancel->callback((Fl_Callback*)sound_cancel);
		bCancel->box(FL_PLASTIC_DOWN_BOX);
		
	sound_load();

	wSound->set_modal();
	wSound->show();
	wSound->end();
	
}
