#include "main.hh"
#include <unistd.h>

Fl_Window *wVideo;
Fl_Choice *cRes,
	  *cBpp;
Fl_Check_Button  *cTrans;

#define N_RES 6
#define N_BPP 3
const char *nRes[]={ "320x200","400x300","640x480","800x600","1024x768","1280x1024" };
const char *nBpp[]={ "16","24","32" };

Fl_Menu_Item cResItems[]=
   { {nRes[0]},{nRes[1]},{nRes[2]},{nRes[3]},{nRes[4]},{nRes[5]},{0} };

Fl_Menu_Item cBppItems[]=
	{{nBpp[0]},{nBpp[1]},{nBpp[2]},{0} };

void video_cancel()
{
	wVideo->hide();
}

void video_load()
{
	char buf[80];
	int i=0;
	FILE *fd;

	fd=fopen("config.vid","r");
	if (!fd) return;
	while(!feof(fd))
	{
		buf[0]=0;
		fscanf(fd,"%s",buf);
		if (!strcmp("BPP",buf))
		{
			fscanf(fd,"%s",buf);
			for(i=N_BPP,--i;i;i--) if(!strcmp(buf,nBpp[i])) break;
			cBpp->value(i);
		} else
		if (!strcmp("RES",buf))
		{
			fscanf(fd,"%s",buf);
			for(i=N_RES,--i;i;i--)if(!strcmp(buf,nRes[i]))break;
			cRes->value(i);
		} else
		if (!strcmp("TEXT",buf))
		{
			fscanf(fd,"%d",&i);
			cTrans->value(i);
		}
	}
	fclose(fd);
}

void video_save()
{
	FILE *fd;
	char str[100];

	fd=fopen("config.vid","w");
	if (!fd) return;
	fprintf(fd,"BPP %s\n",nBpp[cBpp->value()]);
	fprintf(fd,"RES %s\n",nRes[cRes->value()]);
	fprintf(fd,"TEXT %d\n\n",cTrans->value());
	fclose(fd);
	video_cancel();
}

void video()
{
	wVideo=new Fl_Window(360,200,"glH - videoconf");

	cRes=new Fl_Choice(190,10,150,25,"Resolution");
	cRes->menu(cResItems);

	cBpp=new Fl_Choice(190,40,150,25,"Bpp");
	cBpp->menu(cBppItems);

	cTrans=new Fl_Check_Button(190,100,160,25,"Transparency");
	
	Fl_Return_Button *bSave=new Fl_Return_Button(80,170,90,25,"&Save");
		bSave->shortcut(FL_Enter);
		bSave->callback((Fl_Callback*)video_save);
		bSave->box(FL_PLASTIC_UP_BOX);

	Fl_Button *bCancel=new Fl_Button(200,170,90,25,"&Cancel");
		bCancel->shortcut(FL_Escape);
		bCancel->callback((Fl_Callback*)video_cancel);
		bCancel->box(FL_PLASTIC_DOWN_BOX);
		
	video_load();

	wVideo->set_modal();
	wVideo->show();
	wVideo->end();
}


