#include "client.h"

extern unsigned int crc32(char *buf, long len);

int
main(int argc, char *argv[])
{
	int	port=9999;
	char    serv[20],buf[100];
	FILE *fd;

	struct	sockaddr_in servaddr;
	struct  hostent *he;
	pthread_t console_thread;
#if WINDOWS
	WSADATA              wsa;
	WORD                 wVersionRequested;
	wVersionRequested = MAKEWORD( 2, 0 );
	if (WSAStartup(wVersionRequested , &wsa)!=0) printf("Error");
#endif

	strcpy(buf,"localhost");

	fd=fopen("config.cli","r");
	if(!fd) 
	{
		printf("Cannot open config.cli\n");
		exit(1);
	}
	while(!feof(fd))
	{
		buf[0]=0;
		fscanf(fd,"%s",buf);
		if (buf[0]=='#') { fgets (buf,80,fd); continue;}
		if (!strcmp(buf,"SERVER"))
			fscanf(fd,"%s",serv); else
		if (!strcmp(buf,"PORT"))
			fscanf(fd,"%d",&port); else
		if (!strcmp(buf,"BUFFER"))
			fscanf(fd,"%d",&bsize);
	}
	fclose(fd);

	printf("Loading glh-client version %s...\n",VERSION);

	he=(struct hostent *)gethostbyname(serv);
	if (he==(struct hostent *)0)
		{
		fprintf(stderr,"Cannot resolve hostname \"%s\"\n",serv);
		return 1;
		}

	if ( (s = socket(AF_INET, SOCK_STREAM, 0)) < 0 )
		{
		fprintf(stderr, "Cannot create socket.\n");
		return 1;
		}
	
	servaddr.sin_family      = AF_INET;
	memcpy((char *)&servaddr.sin_addr, he->h_addr, he->h_length);
	servaddr.sin_port        = htons(port);

	if (
	connect (s, (struct sockaddr *) &servaddr, sizeof(servaddr))
		) {
		fprintf(stderr,"Cannot connect to remote server \"%s:%d\"\n",serv,port);
		return 1;
		}

	printf("Connected to host %s at port %d.\n",serv,port);
	pthread_create(&console_thread,NULL,console,NULL);

	while ( 1 )
	{
		int n;
		char buf[2];
		n=recv(s,buf,1,0);
		   if (n<0)	{
			fprintf(stderr,"Error on recv (%d).\n",n);
			break;
			}
		   if (!n) {
			   perror("recv=0; waiting..\n");
			   break;
		   }
		switch(buf[0])
		{
		case PACKET_VERS: cli_reciveVers();	break;
		case PACKET_PKEY: cli_reciveKey();	break;
		case PACKET_ERRR: cli_packetErr();	break;
		case PACKET_TALK: cli_reciveTalk();	break;
		case PACKET_CHKF: cli_checkFile();	break;
		case PACKET_FILE: cli_saveFile();	break;
		case PACKET_MOVE: cli_reciveMove();	break;
		case PACKET_PART: cli_recivePart();	break;
		case PACKET_ITEM: cli_reciveItem();	break;
		case PACKET_BEGN: cli_reciveBegin();	break;
		case PACKET_WEAP: cli_reciveWeapon();	break;
		case PACKET_JOIN: cli_reciveJoin();	break;
		case PACKET_OKOK: cli_reciveOkOk();	break;
		default: 
		     fprintf(stderr,"Unknown data recived :/ (%d)\n",buf[0]);
		     exit(1);
		     break;
		}
	}
	close(s);
	return 0;
}

void *console(void *arg)
{
	char buf[80];

	unsigned int i,j;
	printf("Console thread throwed.\n");
	while(1)
	{
		printf("ch> ");
		buf[0]=0;
		fflush(stdin);
		fgets(buf,200,stdin);
		if (!strcmp(buf,""));
		else
		if (!strncmp(buf,"quit",4))
		{
			shutdown(s,0);
			printf("Connection closed by client.\n");
			exit(1);
		} else
		if (!strncmp(buf,"help",4))
		{
		printf( "Commands:\n"
                "  user username    : send username to server\n"
                "  pass password    : send password to server\n"
		"  okok             : send an okok packet\n"
		"  talk message     : send a global message\n"
		"  move x.0 y.0 z.0 rotation animation : move\n"
		"  weap [n]         : change to next or N weapon\n");
		} else
		if (!strncmp(buf,"ping",4))
		{
			if (strlen(buf)<6)
			{
			printf(">Usage: ping username\n");
			} else
			{
			printf(">pinging to %s.\n",buf+5);
			send(s,"\01\07pancake",9,0);
			}
		} else
		if (!strncmp(buf,"user",4))
		{
			if(strlen(buf)<6)
			{
			printf(">Usage: user username\n");
			} else
			{
			char b[300];
			b[0]=PACKET_USER;
			b[1]=strlen(buf+5)-1;
			memcpy(b+2,buf+5,b[1]);
			send(s,b,b[1]+2,0);
			printf("Nick length: %d\n",b[1]);
			}
		} else
		if (!strncmp(buf,"pass",4))
		{
		unsigned int crc;
		char *b;

			if (strlen(buf)<6)
			printf(">Usage: pass password");
			else {
			for(i=0;i<4;i++)
				for(j=5; j<(5+strlen(buf+5));j++)
					buf[j]^=key[i];
			crc=crc32(buf+5,strlen(buf+5)-1); // es veu q conta el \n ://
			crc=htonl(crc); // inter-architecture save
			buf[0]=PACKET_PASS;
			b=(char *)&crc;
			memcpy(buf+1,b,4);
			send(s,buf,5,0);
			printf("KEY SENT: [%2x:%2x:%2x:%2x]\n",
				(unsigned char)b[0],
				(unsigned char)b[1],
				(unsigned char)b[2],
				(unsigned char)b[3]);
			}
		} else
		if (!strncmp(buf,"okok",4))
		{
			char b[1]={PACKET_OKOK};
			send (s,b,1,0);
		} else
		if (!strncmp(buf,"talk",4))
		{
			if(strlen(buf)<6)
			{
			printf(">Usage: talk message\n");
			} else
			{
			char b[300];
			b[0]=PACKET_TALK;
			b[1]=strlen(buf+5);
			memcpy(b+2,buf+5,b[1]);
			send(s,b,b[1]+2,0);
			}
		} else
		if (!strncmp(buf,"nick",4))
		{
			if (strlen(buf)<6)
			{
			printf(">Usage: nick newnickname\n");
			} else {
			char b[300];
			buf[5+strlen(buf+5)]=0;
			b[0]=PACKET_NICK;
			b[1]=strlen(buf+5);
			memcpy(b+2,buf+5,b[1]);
			send(s,b,b[1]+2,0);
			}	
			
		} else
		if (!strncmp(buf,"move",4))
		{
			int i,n=0;
			float x,y,z;
			int rot,ani;
			char *pkt;
			
			for(n=0,i=strlen(buf);i--;)
				if (buf[i]==' ') n++;
			if (n!=5) {
				printf(">Usage: move x y z rot numanim\n");
			} else {
			char b[300];
			b[0]=PACKET_MOVE;
			sscanf(buf+4,"%f %f %f %d %d",&x,&y,&z,&rot,&ani);
			printf("%f - %f - %f (%d, %d) \n",x,y,z,rot,ani);
			// ?to?? sux on float.
			//x=htonl(x); y=htonl(y); z=htonl(z); // convert to network data
			// Generate packet
			b[0]=PACKET_MOVE;
			memcpy(b+1,&x,4); memcpy(b+5,&y,4); memcpy(b+9,&z,4);
			b[13]=(char)(int)rot/2;
			b[14]=(char)ani;
			send(s,b,15,0); // Send move packet
			}
		} else
		if (!strncmp(buf,"weap",4))
		{
			char b[2];
			if (strlen(buf)>5)
			{
			int n;
			sscanf(buf+4,"%d",&n);
			b[0]=PACKET_WEAP; // change to weapon N.
			b[1]=n;
			send(s,b,2,0);
			} else {
			b[0]=PACKET_CHWP; // change to the next weapon
			send(s,b,1,0);
			}
		} else
		{
			printf("Unknown command, try help ;)\n");
		}
	}
}
