#ifndef _INCLUDE_PACKET_H_
#define _INCLUDE_PACKET_H_


//
// [x] -> packet yet implemented to protocol
// [ ] -> not yet.
//
enum {
	PACKET_PING=0, // [ ] send a ping    usr->svr (n,"username",rnd); svr->usr(from,rnd);
	PACKET_PONG,   // [ ] reply a ping   (n,"username",rnd);
	PACKET_USER,   // [x] Send username  (n,"username");
	PACKET_PKEY,   // [x] Server sends the password key
	PACKET_PASS,   // [x] Send password  (crc); (4 bytes)
	PACKET_ERRR,   // [x] Errror ;)      (n,"errormessage"); -> close connection
	PACKET_VERS,   // [x] Send server Version (version,n,"serverstring");
	PACKET_CHKF,   // [x] Check file     (n,"filename");
	PACKET_CRCF,   // [x] Reply a crc32 of the file requested.
	PACKET_FILE,   // [x] Send a file to the client. (n,"filename",n[4],"filedata");
	PACKET_NICK,   // [x] Change my nick (n,"nick");
	PACKET_TALK,   // [x] Talk message :D
	PACKET_MOVE,   // [x] Move message...100% done
	PACKET_PART,   // [x] Send a broadcast message [header][1 byte of usrenumber]
	PACKET_JOIN,   // [x] JoinMessage (me/nick/rph)
	PACKET_ITEM,   // [x] Item packet [2 bytes]
	PACKET_BEGN,   // [x] Begin is love [x,y,z,r]
	PACKET_WEAP,   // [x] Change Weapon [n]
	PACKET_CHWP,   // [x] Change next weapon
	PACKET_OKOK,   // [x] Prepared to play?
	PACKET_DEPS,   // [x] Unlock deps          ( undocumented )
	PACKET_SHOT,   // [x] Shot gun!            ( undocumented )
	PACKET_ROLE    // [ ] Give Role data
};

#endif
