#include "Database.h"

Database::Database(const char *svr, int port)
{
	this->setServer(svr,port);
}

Database::~Database()
{
	delete this->svr;
}

void Database::setServer(const char *svr, int port)
{
	delete this->svr;
	this->svr=new char[strlen(svr)+1];
	strcpy(this->svr,svr);
	this->port=port;
}

const char *Database::getServer()
{
	return this->svr;
}

int Database::getPort()
{
	return this->port;
}

long Database::authUser(char *username, char *pwd, char *key)
{
	long ret=0,i;
	char *buf=new char[4096],*b;

	sprintf(buf,"GET /db.php?type=auth&usr=%s&pwd=%d,%d,%d,%d&key=%d,%d,%d,%d\n\n",
			username, 
			pwd[0], pwd[1], pwd[2], pwd[3],
			key[0], key[1], key[2], key[3] );
	sendData(buf); /* Send */
	memset(buf,'\0',4096);
	recvData(buf,4000); /* Recv */

	for(i=0;buf[i];i++) { if (buf[i]=='\n') { buf[i]=0; break; } }
	if (strlen(buf)>3)
	{
		if (!strncmp("-ER:",buf,4))
		{
			printf("Error: %s\n",buf+4);
			return -2;
		} else 
		if (!strncmp("+OK:",buf,4))
		{
			char *model,str[100];
			long id;
			FILE *fd;

			printf("+OK: %s\n",buf+4);
			id=atol(buf+4);
			b=buf+strlen(buf)+1;
			sprintf(str,"%s.rph",username);
			fd=glh_fopen(str,"w");
			if (!fd)
			{
				printf("Cannot open %s for writting\n",str);
				return 0;
			}
			fprintf(fd,"%s",b);
			glh_fclose(fd);
			model=strtok(buf+strlen(buf)+1,"MODEL")+1;

			for(i=0;model[i];i++) { if (model[i]=='\n')
				{ model[i-1]=0; break; } }
			printf("MODEL IS : %s\n",model);
			this->getFile(model);
			ret=id;
		}
	} else {
		printf("Invalid data recived.\n");
		ret=-1;
	}
	delete buf;
	return ret;
}

long Database::recvData(char *string,long size)
{
	long i,n;
	#define DLR 32768
	
	for(i=0;i<size;i+=((i+DLR)>size)?size-i:DLR)
	{
		n+=recv(this->sock,string+i,((i+DLR)>size)?size-i:DLR,0);
	}
	this->DBdisconnect();
	return n;
}

int Database::DBconnect()
{
	struct hostent *he;
	struct sockaddr_in addr;
#if WINDOWS
	WSADATA wsa;
	WORD    wVersionRequested;
	wVersionRequested = MAKEWORD(2,0);
	if (WSAStartup(wVersionRequested, &wsa) )
		return -1;
#endif
	he=(struct hostent*)gethostbyname(this->svr);
	if (he==(struct hostent*)0)
		{
		printf("Cannot resolve hostname '%s'.\n",this->svr);
		return -1;
		}
	if ( (this->sock=socket(AF_INET,SOCK_STREAM,0))<0 )
		{
		printf("Cannot create socket\n");
		return -1;
		}
	addr.sin_family=AF_INET;
	memcpy((char *)&addr.sin_addr, he->h_addr, he->h_length);
	addr.sin_port=htons(this->port);

	if ( connect(this->sock,(struct sockaddr *)&addr,sizeof(addr)) )
	{
		printf("Cannot connect to remote server '%s'\n",this->svr);
		return -1;
	}
	return 0;
}

int Database::DBdisconnect()
{
	close(this->sock);
}

int Database::readline(char *str,int size)
{
	int i=0;
	for (i=0; i<size && str[i-1]!='\x0D';i++)
	{
		if (recv(this->sock,str+i,1,MSG_WAITALL)<1) return 0;
	}
	recv(this->sock,str+i,1,MSG_WAITALL); // get \x0A
	str[i]=0;
	return i;
}

int Database::getDeps(char *string)
{
	char *ext=string+strlen(string)-4;
	char buf[1024];
	enum { NOT=0, CAR, MDH };
	int  cas=NOT;
	FILE *fd;

	if (!strcmp(".car",ext))      cas=CAR;
	else if (!strcmp(".mdh",ext)) cas=MDH;

	if (cas)
	{
		fd=glh_fopen(string,"r");
		if (!fd)
		{
			printf("Cannot open file: %s\n",string);
			return 0;
		}
		while(!feof(fd))
		{
			fscanf(fd,"%s",buf);
			switch(cas)
			{
			case MDH:
				if (buf[0]=='#')
				{
					fgets(buf,1024,fd);
				} else
				if (buf[0]=='&')
				{
				if (!strcmp("&TEXTURE",buf))
					{
					fscanf(fd,"%s",buf);
					this->getFile(buf);
					} else fgets(buf,1024,fd);
				} else goto finish;
				break;
			case CAR:
				if ((!strcmp("BODY",buf))||
				    (!strcmp("HEAD",buf))||
				    (!strcmp("LEGS",buf)))
				{
					fscanf(fd,"%s",buf);
					this->getFile(buf);
				} else goto finish;
				break;
			}
		}
		finish:
		glh_fclose(fd);
	}
	return 1;
}

int Database::getFile(char *string)
{
	int i=0;
	long filesize=0;
	char *buf = new char[30+strlen(string)];
	FILE *fd;

	printf("==> Getting file %s ...",string);
	sprintf(buf,"GET /dbfiles/%s HTTP/1.0\n\n",string);
	this->sendData(buf);
	delete buf;
	buf=new char[4096];
	memset(buf,0,4096);
	
	readline(buf,4000);
	if (!strstr(buf,"200 OK"))
	{
		printf("Error: File Not found\n");
		return 0;
	}
	
	while(readline(buf,4000))
	{
		char *tok;
		tok=strstr(buf,"Content-Length: ");
		if (tok)
		{
			if (filesize) 
			{
				printf("Strange Header recived\n");
				return 0;
			}
			filesize=atol(tok+strlen("Content-Length: "));
		}
		tok=strstr(buf,"Content-Type: ");
		if (tok)
		{
			readline(buf,4000);
			printf("size is %d\n",filesize);
			break;
		}
	}
	
	if (!filesize)
	{
		printf("Strange header recived\n");
		return 0;
	}
	delete buf;
	buf=new char[filesize];
	this->recvData(buf,filesize);

	fd=glh_fopen(string,"w");
	fwrite(buf,filesize,1,fd);
	glh_fclose(fd);

	this->getDeps(string);
	
	delete buf;
	return 1; // +OK
}

int Database::sendData(char *string)
{
	if ( this->DBconnect() != 0 )
	{
		return -1;
	}

	if ( send(this->sock,string,strlen(string),MSG_WAITALL) <=0 )
	{
		printf("Error sending data.\n");
		return -1;
	}

	return 0;
}

int Database::sendKeepAlive(char *nick, long ID)
{
	char *buf=new char[400];
	int ret=0;

	sprintf(buf,"GET /db.php?type=kal&usr=%s&id=%ld\n\n",nick,ID);
	this->sendData(buf);
	this->recvData(buf,10);
	if (!strcmp("OK",buf)) ret=1;
	
	delete buf;
	return ret;
}

int Database::deauthUser(char *nick, long ID)
{
	char *buf=new char[400];

	sprintf(buf,"GET /db.php?type=del&usr=%s&id%l\n\n",nick,ID);
	this->sendData(buf);

	delete buf;
}



