#include "client.h" 

void glh_sendServerVersion(int me)
{
	int s=client.p[me].sock;
	char buf[3];
	buf[0]=PACKET_VERS;
	buf[1]=SERVER_VERS;
	buf[2]=strlen(cfg.hellomsg);

	send(s,buf,3,0);
	send(s,cfg.hellomsg,buf[2],0);
}

char *getPasswordFromFile(int me)
{
	FILE *fd;
	char buf[100];

	fd=fopen(cfg.login_opt,"r");
	if (!fd) 
	{
		printf("pwd:\n");
		system("pwd");
		printf("[e] Password file '%s' not found :(\n",cfg.login_opt);
		exit(1);
	}

	while(!feof(fd))
	{
	  buf[0]=0;
	  fscanf(fd,"%s",buf);
		if (buf[0]=='#' || strcmp(buf,client.p[me].nick)) 
		{
		   fgets(buf,100,fd); // saltar linea
		}
		else
		{
		  fscanf(fd,"%s",buf); // return the password of this user
		  client.p[me].pwd=(char *)malloc(strlen(buf)+1);
		  if (!client.p[me].pwd) return 0;
		  strcpy(client.p[me].pwd,buf);
		  fscanf(fd,"%s",buf); // get RPH filename
		  client.p[me].rph=(char *)malloc(strlen(buf)+1);
		  if (!client.p[me].rph) return 0;
		  strcpy(client.p[me].rph,buf);

		  fclose(fd);
		  return client.p[me].pwd;
		}
	}

	fclose(fd);
	return 0;
}

void glh_readUser(int me)
{
	int i,j,pwdlen;
    	int s=client.p[me].sock;
	char b[5],*pwd;

	if (client.p[me].wait.ing)
		if(client.p[me].wait.what!=PACKET_USER)
		{
			glh_closeConnection(me,"Don't relogin!");
		}
	if (client.p[me].login)
	{
		glh_closeConnection(me,"No relogin allowed!");
	}
	recv(s,b,1,0); // read length of name
	if (b[0]>cfg.maxnick)
	{
		glh_closeConnection(me,"Nickname too long");
		printf("   Nickname too long, connection closed\n");
		return;
	} else 	{
    		client.p[me].nick = (char *) malloc( b[0]+1 );
		recv(s,client.p[me].nick,b[0],0); // recive username
		client.p[me].nick[b[0]]=0; //end of string
		
		if (nickIsUsed(me,client.p[me].nick))
		{
			printf("His nick is : %s\n",client.p[me].nick);
		  glh_closeConnection(me,"Nick is already used");
		  return;
		}
		
		printf("    User nick is %s\n",client.p[me].nick);
		client.p[me].login=true;
		client.p[me].wait.ing=true;
		client.p[me].wait.what=PACKET_PASS;

		glh_srand();

		b[0]=PACKET_PKEY;
		for(i=0;i<4;i++) b[i+1]=rand()%256;
		send(s,b,5,0); // send my key :)
		printf("    Key sent: %2x:%2x:%2x:%2x\n",
			(unsigned char)b[1],
			(unsigned char)b[2],
			(unsigned char)b[3],
			(unsigned char)b[4]);

		switch(cfg.login)
		{
		case LOGIN_CUSTOM:
			pwd=getPasswordFromFile(me);
			if (pwd==0)
			{
			glh_closeConnection(me,"Invalid login");
			return;
			}
			pwdlen=strlen(pwd);
			printf("    His password is : %s (%d)\n",pwd,pwdlen);
			printf("    His rph is : %s \n",client.p[me].rph);
			for(i=1;i<5;i++) for (j=0;j<pwdlen;j++)
				pwd[j]^=b[i];
			client.p[me].crc=crc32(pwd,pwdlen);
			break;
		case LOGIN_ANONYMOUS:
			printf("[i] Server in anonymous mode...not check password\n");
			/*
			{ // Testing pawah!
				char *n;
				n=(char *)&client.p[me].crc;
				printf("    MY CRC= %d %d %d %d\n",n[0],n[1],n[2],n[3]);
			}*/
		case LOGIN_OFFICIAL:
			printf("[i] Official mode\n");
			memcpy(client.p[me].key,b,4);
			client.p[me].rph=(char *)realloc(
				client.p[me].rph,strlen(client.p[me].nick+5));
			sprintf(client.p[me].rph,"%s.rph", client.p[me].nick);
			break;
		default:
			printf("[i] Invalid login mode. check configuration\n");
			glh_closeConnection(me,"Invalid login mode");
			return;
		}
	}
}

void glh_readPass(int me)
{
    int s=client.p[me].sock;
    char b[4];
    char *str;
    unsigned char *ccrc; // Client crc
    unsigned int *c;

	if (client.p[me].wait.ing)
		if(client.p[me].wait.what!=PACKET_PASS)
		{
			glh_closeConnection(me,"Don't relogin!");
		}
		recv(s,b,4,0); // get the key
		c=(unsigned int *)b;
		*c=ntohl(*c);
	switch(cfg.login)
	{
	case LOGIN_OFFICIAL:
		printf("Logging official user...\n");
		client.p[me].ID=
		cfg.db->authUser(	client.p[me].nick,
					b,
					client.p[me].key);
		if (!client.p[me].ID)
		{
			glh_closeConnection(me,"OfficialServer says: Acces denied");
			return;
		}
		loadRoleData(me,client.p[me].rph);
		break;
	case LOGIN_ANONYMOUS:
		printf("[i] anon user +ok\n");
		loadRoleData(me,"default.rph");
	        break;
	case LOGIN_CUSTOM:
		if (*c!=client.p[me].crc)
		{
		ccrc=(unsigned char *)&client.p[me].crc;
		printf("[e] Invalid password ( client:[%2x:%2x:%2x:%2x] vs server:[%2x:%2x:%2x:%2x]\n",
				// Client
				(unsigned char)b[0],
				(unsigned char)b[1],
				(unsigned char)b[2],
				(unsigned char)b[3],
				// Server
				(unsigned char)ccrc[0],
				(unsigned char)ccrc[1],
				(unsigned char)ccrc[2],
				(unsigned char)ccrc[3]
				);
		glh_closeConnection(me,"Invalid password");
		return;
		}
		loadRoleData(me,client.p[me].rph);
		break;
	default:
		printf("Login method not supported\n");
	}

    // Inform to the party of this new join :)
        str=(char *)malloc(2);
	str[0]=PACKET_TALK;
	str[1]=me;
	str[2]=strlen(" joins the game.")+strlen(client.p[me].nick);
	str=(char *)realloc(str,5+str[2]+5);
	sprintf(str+3,"%s joins the game.",client.p[me].nick);
	glh_broadcast(me,str,str[2]+3);
	
    // check file dependencies.
	client.p[me].pdep=0;
	client.p[me].wait.ing  = true;
	client.p[me].wait.what = PACKET_CRCF; // Waiting for crc reply.

    // client.status -> pointer to data
    // this packet will begin the deps loop
	b[0]=PACKET_CHKF;
	b[1]=strlen(cfg.dep+client.p[me].pdep);
	send(client.p[me].sock,b,2,0);
	send(client.p[me].sock,cfg.dep+client.p[me].pdep+4,b[1],0);
	printf("   | Checking dep.\n");
}


/**          .
 * Read NICK *
 .          **/ 

int nickIsUsed(int me, char *b)
{
	int i;
	for(i=0;i<client.n;i++)
	{
		if (i==me) continue;

		if (client.p[i].sock)
		if (client.p[i].login)
		if (!strcmp(b,client.p[i].nick))
			return 1; // nick used
	}
	return 0; // not used
}

void glh_readNick(int me)
{
	char *b;
	int s=client.p[me].sock;
	int l;
	
	if (!cfg.chNick) return;

	b=(char *)malloc(256);
	recv(s,b,1,0); // read nick length
	l=b[0];
	recv(s,b,l,0); // read nick string
	b[l]=0;   // "string\0"
	if (l>cfg.maxnick)  // nickname too long
	{
		b[0]=PACKET_TALK;
		b[1]=17;
		memcpy(b+2,"Nickname too long",17);
		send(s,b,19,0);
	} else
	if (nickIsUsed(me,b)) // cal comprobar si el nick esta al config.pwd
	{
		b[0]=PACKET_TALK;
		b[1]=24;
		memcpy(b+2,"Nickname is already used",24);
		send(s,b,26,0);
	} else {
	char *str,buf[2];
	// inform of this fact to the rest of users.
	buf[0]=PACKET_TALK;
	buf[1]=strlen(" is now called ")+
	       strlen(client.p[me].nick)+
	       strlen(b);
	str = (char *) malloc(buf[1]+1+2);
	sprintf(str+2,"%s is now called %s",client.p[me].nick, b);
	str[0]=buf[0];
	str[1]=buf[1]; // code warroh
	printf("[i] %s is now called %s\n",client.p[me].nick,b);
	glh_broadcast(me,str,str[1]+2);
	}

	// Put new nick on client structure
	client.p[me].nick=(char *)
		realloc(client.p[me].nick,strlen(b)+1);
	memcpy(client.p[me].nick,b,l+1);
	
	free(b);
}



