#include "client.h" 

int getClient(int s)
{
	int i=0;

	// register the new user to the global struct
	printf("[>] Client added to roster\n");

	for(i=0;i<client.n;i++)
	  if (!( client.p[i]).sock) break; // find any free struct

	if (i==client.n)
	{
	  client.n++;
	  client.p=(Client_info *)
                      realloc(client.p,client.n*sizeof(Client_info));
	}

	pthread_mutex_init (&client.p[i].lock,NULL);
	pthread_mutex_lock (&client.p[i].lock);

	client.p[i].sock=s;
	client.p[i].wait.ing=true;
	client.p[i].wait.what=PACKET_USER;
	client.p[i].rph=0;
	client.p[i].nick=0;
	client.p[i].pwd=0;
	
	if (i>cfg.maxconn)
	{
		printf("[L] User exceeds server limits.\n");
		glh_closeConnection(i,"Server exceed limit of users\n");
	} else 
	pthread_create(&client.p[i].thread, NULL,clientWorker,(void *)i);
	
	pthread_mutex_unlock(&client.p[i].lock);

	return 0;
}

void loadCarData(int me)
{
	#define N1 3
	char buf[100];
	int i,j;
	FILE *fd,*fd2;
	float foot=0.0f,legs=0.0f,head=0.0f; // y pos.
	float u_legs=0.0f,u_body=0.0f;
	struct { bool chk;
		 char *nom;
	} data[N1]= { { 0,"HEAD" },
		      { 0,"BODY" },
		      { 0,"LEGS" } };
	
	i=cfg.pdeps;
	sprintf(buf,"%s/%s",getDirs(client.p[me].car),client.p[me].car);
	if ( addDep(&i,buf) )
	{
		glh_closeConnection(me,"Cannot open Car file");
		return;
	}
	cfg.pdeps=i;                                                    	

	fd=fopen(buf,"r");
	if (!fd)
	{
		printf("[e] Strange thing... addDep says another thing. (%s)\n",buf);
		glh_closeConnection(me,"Strange...Cannot open Car file");
		return;
	}
	while(!feof(fd))
	{
		buf[0]=0;
		fscanf(fd,"%s",buf);
		
		if (!strcmp(buf,"LEGS_UNION_POINTS"))
		{
			int n; float x;
			fscanf(fd,"%d",&n);
			fscanf(fd,"%f %f %f",&x,&u_legs,&x);
			for(--n;n;n--) /// read the rest
				fgets(buf,80,fd);
		} else
		if (!strcmp(buf,"BODY_UNION_POINTS"))
		{
			int n; float x;
			fscanf(fd,"%d",&n);
			fscanf(fd,"%f %f %f",&x,&u_body,&x);
			for(--n;n;n--) /// read the rest
				fgets(buf,80,fd);
		} else
		for(i=0;i<N1;i++) // HEAD,BODY,LEGS
		{
			if (!strcmp(buf,data[i].nom))
			{
				char tb[100];
				int text=false; // animation
				bool isHead=(!strcmp(buf,"HEAD"))?true:false;

				printf("WOPING: %s\n",buf);
				tb[0]=0;
				data[i].chk=true;
				fscanf(fd,"%s",tb);
				sprintf(buf,"%s/%s",getDirs(tb),tb);
				j=cfg.pdeps;
				if ( addDep(&j,buf) )
				{
					glh_closeConnection(me,"Cannot load car model");
					return;
				}
				// Add texture model as dep
				fd2=fopen(buf,"r"); // check his existence with with addDep
				if (!fd2)
				{
					glh_closeConnection(me,"Cannot found that ://");
					return;
				}
				while(!feof(fd2))
				{
					tb[0]=0;
					fscanf(fd2,"%s",tb);
					if (!strcmp(tb,"&TEXTURE"))
					{
						char tb2[100];
						fscanf(fd2,"%s",tb);
						sprintf(tb2,"%s/%s",getDirs(tb),tb);
						cfg.pdeps=j;
						if ( addDep(&j,tb2) )
						{
						printf("Cannot load texture: %s\n",tb2);
						glh_closeConnection(me,"Cannot load texture on mdh");
						return;
						}
						cfg.pdeps=j;
						text=true;
					} else
					if (isHead && tb[0]=='*')
					{
						float x,y;
						sscanf(tb,"%f %f %f",&x,&y,&x);
						head=y;
						printf("WOPING HEAD\n");
						do
						{
							fgets(tb,80,fd);
							if (tb[0]=='.'||tb[0]=='*') break;
							sscanf(tb,"%f %f %f",&x,&y,&x);
							if (y > head) head = y;
						} while(!feof(fd));
					}
				}
				if (!text)
				{
					glh_closeConnection(me,"Texture not found on model");
				}
				fclose(fd2);
				break;
			}
		}
	}
	fclose(fd);

	if (!head)
	{
	glh_closeConnection(me,"Null head exception xD");
	} 
		
	// Test correct data readed.
	for(i=0;i<N1;i++) if (!data[i].chk) glh_closeConnection(me,"Invalid CAR");

	// Generate user heights x) 90-60-90 xD
	head*=cfg.ratio;
	u_legs*=cfg.ratio;
	u_body*=cfg.ratio;
	client.p[me].heights.head   = head+u_body+u_legs;
	client.p[me].heights.knee   = u_legs/2;
	client.p[me].heights.u_body = u_body;
	client.p[me].heights.u_legs = u_legs;
}

void loadRoleData(int me, char *f)
{
	#define N 8
	FILE *fd;
	int i=cfg.pdeps;
	char buf[100];
	struct {
		bool chk;
		char *nom; // "string"
		char *m;   // %d %f %s
		void *p;   // pointer
	} data[N] = 
	 { {0,"DEFENSE",   "%d", &client.p[me].rpg.base[DEFENSE] },
	   {0,"LIFE",      "%d", &client.p[me].rpg.base[LIFE] },
	   {0,"AIM",       "%d", &client.p[me].rpg.base[AIM] },
	   {0,"SPEED",     "%d", &client.p[me].rpg.base[SPEED] },
	   {0,"STRENGTH",  "%d", &client.p[me].rpg.base[STRENGTH] },
	   {0,"LEVEL",     "%d", &client.p[me].rpg.level },
	   {0,"EXPERIENCE","%d", &client.p[me].rpg.experience },
	   {0,"MODEL",     "%s", client.p[me].car }
	 };

	// Add this new Dep.
	sprintf(buf,"%s/%s",getDirs(f),f);
	addDep(&i,buf);
	cfg.pdeps=i;

	fd=glh_fopen(f,"r");
	if (!fd) 
	{
		glh_closeConnection(me,"rph not found on server :/");
		return;
	}
	while (!feof(fd))
	{
		buf[0]=0;
		fscanf(fd,"%s",buf);
		
		for (i=0;i<N;i++)
		if (!strcmp(buf,data[i].nom))
		{
			data[i].chk=true;
			fscanf(fd,data[i].m,data[i].p);
			break; 
		}
	}
	glh_fclose(fd);

	// Test Role Data and fill blanks.
	for (i=0;i<N;i++)
		if (!data[i].chk) glh_closeConnection (me,"invalid RPH");

	// add Model Dep
	loadCarData(me);

	// add User to world
	loadEntity(me);

	// Default RPG data
	client.p[me].rpg.weapon=0;
	client.p[me].rpg.weaps=1;
	for(i=0;i<SHIELD_MAX;i++)
	client.p[me].rpg.shield[i]=0;
	for(i=0;i<MOD_MAX;i++)
	client.p[me].rpg.mod[i]=0;
	client.p[me].rpg.weapons=(weapons_ *)
		malloc( cfg.weaps * sizeof(weapons_));
	client.p[me].rpg.weapons[0].haveit=true;
	client.p[me].rpg.weapons[0].munition=1;
	client.p[me].rpg.weapons[0].type=cfg.wp[0].munition;
	for(i=1;i<cfg.weaps;i++)
	{
		client.p[me].rpg.weapons[i].haveit=false;
		client.p[me].rpg.weapons[i].munition=0;
		client.p[me].rpg.weapons[i].type=0;
	}

	return;
}

void *clientWorker(void *arg)
{
	int me=(int)arg;
	int s=client.p[me].sock;
	char buf[1];

	printf("    Client is son %d\n",me);
	glh_sendServerVersion(me);
	client.p[me].login=false;
	client.p[me].onplay=false;

	while (1)
	{
	 if (!client.p[me].sock)
	 {
		printf("[e] User %d suxx\n",me);
		break;
	 } 
	 else if (recv(s,buf,1,0) <1) 
	 {
		 printf("[e] User %d wops\n",me);
		 break;
	 }
	 else
	 {
	 	pthread_mutex_lock(&client.p[me].lock);
		if ( analizePackage(me,buf[0]) ) break;
		pthread_mutex_unlock(&client.p[me].lock);
	 }
	}

	close(s);
	glh_closeConnection(me,"client eof");
	pthread_exit(NULL);
	return 0;
}


int analizePackage(int me, char buf)
{
	/* // Optimize reasons xD
	if (client.p[me].wait.ing)
		if (client.p[me].wait.what!=buf)
		{
		glh_closeConnection(me,"Unexpected packet recived");
		printf("[e] Waiting for %d , recived %d.\n",
				client.p[me].wait.what,buf);
		return 1; // error
		}
    */
	switch(buf)
	{
	case PACKET_USER:	glh_readUser(me);	break;
	case PACKET_PASS:	glh_readPass(me);	break;
	case PACKET_TALK:	glh_readTalk(me);	break;
	case PACKET_NICK:	glh_readNick(me);	break;
	case PACKET_CRCF:       glh_readCrcf(me);	break;
	case PACKET_MOVE:	glh_readMove(me);	break;
	case PACKET_WEAP:	glh_readWeap(me);	break;
	case PACKET_CHWP:	glh_readChwp(me);	break;
	case PACKET_OKOK:	glh_readOkOk(me);	break;
	case PACKET_SHOT:       glh_readShot(me);	break;
	default:
		printf("[?] Unrecognized packet %d\n",buf);
		glh_closeConnection(me,"Unrecognized packet recived");
		break;
	}

    return 0; // +ok
}

void glh_readOkOk(int me)
{
	char b[300];
	int n=0,i;

	printf ("OkOk!!!\n");
	client.p[me].wait.ing=false;
	pthread_mutex_unlock(&cfg.deplock);
//	pthread_mutex_unlock(&client.p[i].lock);
	printf("UNLOCKED\n");
	
	glh_sendRoleData(me);
	// send Begin Point
	glh_sendBeginPoint(me, -1); // get random

	//sendJoins()!!! (warroh code)
	for(i=0;i<client.n;i++)
	{
		if (!client.p[i].sock) continue;
		int nicklen,rphlen;
	//	if (i==me) continue;
		nicklen=strlen(client.p[i].nick);
		rphlen=strlen(client.p[i].rph);
		b[n++]=PACKET_JOIN;
		b[n++]=i;
		b[n++]=nicklen;
		memcpy(b+n,client.p[i].nick,b[n-1]);
		n+=nicklen;
		b[n++]=rphlen;
		memcpy(b+n,client.p[i].rph,b[n-1]);
		n+=rphlen;

		send(client.p[me].sock,b,n,0);
	}
	client.p[me].wait.ing=false;
	client.p[me].wait.what=0;

	b[0]=PACKET_DEPS;
	glh_broadcast(-1,b,1);
	//send(client.p[me].sock,b,1,0);

	return;
}

void glh_closeConnection(int me, char *str)
{
	int s;
	char buf[2];

	s=client.p[me].sock;
	if (cfg.login==LOGIN_OFFICIAL)
	{
	   cfg.db->deauthUser(client.p[me].nick,client.p[me].ID);
	}

	exitEntity(me);

	if (str==NULL) return;
	if (s && str[0])
	{
	// Broadcast part
	if (client.p[me].login)
	{
		buf[0]=PACKET_PART;
		buf[1]=me;
		glh_broadcast(me,buf,2);
	}

		printf("[<]   Client %d liberated. reason(\"%s\").\n",me,str);
		buf[0]=PACKET_ERRR;
		buf[1]=(char)strlen(str);
		send (s,buf,2,0);
		send (s,str,buf[1],0);

		close (client.p[me].sock);
		pthread_mutex_unlock(&client.p[me].lock);
		client.p[me].sock=0;
		if (client.p[me].rph)
			free (client.p[me].rph);
		if (client.p[me].nick)
			free (client.p[me].nick);
		if (client.p[me].pwd)
			free (client.p[me].pwd);
		if (client.p[me].wait.ing) 
		{
			pthread_mutex_unlock(&cfg.deplock);
		}
		client.p[me].wait.ing=false;
		client.p[me].wait.what=0;
	}
}

void glh_readTalk(int me)
{
	int s=client.p[me].sock;
	char buf[3],str[300];
	int len;

	if (cfg.v>1) printf("[T] Recived talk message\n");

	buf[0]=PACKET_TALK;// Packet
	buf[1]=me;         // Who
	recv(s,buf+2,1,0); // Strlen
	len=buf[2];
	buf[2]+=strlen(client.p[me].nick)+2; // AddNick+": "
	memcpy(str,buf,3);
	sprintf(str+3,"%s: ",client.p[me].nick);
	recv(s,str+strlen(client.p[me].nick)+5,len+2,0);

	glh_broadcast(-1,str,buf[2]+3);
//	glh_broadcast(me,str,buf[2]+3);
//	send(client.p[me].sock,str,buf[2]+3,0);

}

void glh_srand()
{
	#if !WINDOWS
	srand(getpid());
	#else
	srand(clock());
	#endif
}

void glh_sendBeginPoint(int me,int n)
{
	bool m=false;
	char b[100];
	int i,rphlen,nicklen;
	// if n<0 -> do random;
	if (n>cfg.sp) n=-1; // gcc bug: n-=--n+1; // n=-1
	do 	{ 
		if (!cfg.sp)
			{
			glh_closeConnection(me,"server-bug: no beginpoints defined");
			return;
			}
		if (n<0) n=rand()%cfg.sp;
		for(i=0;i<client.n;i++)
		{
			if (!client.p[i].sock)continue;
			if (! checkBounding(	cfg.stp[n].x,
						cfg.stp[n].y,
						cfg.stp[n].z,
						// user data
						client.p[i].x,
						client.p[i].y,
						client.p[i].z
						))
				{ m=false;break; }
		}
		if (m) sleep(1);
		} while( m );

	client.p[me].x=cfg.stp[n].x;     //\ 
	client.p[me].y=cfg.stp[n].y;     // \  
	client.p[me].z=cfg.stp[n].z;     //  Position
	client.p[me].rot=(int)cfg.stp[n].r;   //  Rotation
	client.p[me].hab=cfg.stp[n].hab; //  Room

#if COLLISION
	cfg.pUnivers->LocateEntity(0,me,ODvector3 (OD_XYZ(client.p[me])) );
#endif
	
	//--- generate packet ---//
	b[0]=PACKET_BEGN;
	memcpy(b+1,&client.p[me].x,4);
	memcpy(b+5,&client.p[me].y,4);
	memcpy(b+9,&client.p[me].z,4);
	memcpy(b+13,&client.p[me].rot,4);
	b[17]=(char)cfg.stp[n].hab;
	send(client.p[me].sock,b,18,0); // me is sent on BEGIN PAQUET!

	printf("User have a begin point\n");

	// Send broadcast of this "join" ;))
	n=0; // pointer
	nicklen=strlen(client.p[me].nick);
	rphlen =strlen(client.p[me].rph);
	b[n++]=PACKET_JOIN;
	b[n++]=me;
	b[n++]=nicklen;
	memcpy(b+n,client.p[me].nick,b[n-1]);
	n+=nicklen;
	b[n++]=rphlen;
	memcpy(b+n,client.p[me].rph,b[n-1]);
	n+=rphlen;
	printf("Total JOIN length %d %d\n",n,b[0]);

	//send(client.p[me].sock,b,n,0);
	//glh_broadcast(me,b,n);
	glh_broadcast (me,b,n);
}


void glh_readCrcf(int me)
{
	int r=999; // x))
	bool m=false;
	FILE *fd;
	int fsize;
	unsigned long i,i2;
	int n, s=client.p[me].sock;
	char b[4],
	     *size,
	     *p=cfg.dep+client.p[me].pdep;

	printf("found as crc [%2x:%2x:%2x:%2x]\n",
			(unsigned char)p[0],
			(unsigned char)p[1],
			(unsigned char)p[2],
			(unsigned char)p[3]);
	recv(s,b,4,0);
	for(i=0;i<4;i++)
		if (b[i]!=(char)p[i]) 
			break;
	
	if (cfg.crcEnabled)			
	if(i<4)
		{
		printf("[d] Client need this file\n");
		// cal enviar paquet.
		// 0 - PACKET_FILE
		// 1 - strlen(filename)
		// ? - string 
		// 4 - fsize
		// ? - file

		b[0]=PACKET_FILE;
		b[1]=strlen(cfg.dep+4+client.p[me].pdep);
		send(s,b,2,0); // enviem el tipus de paquet i la long. del nom
		send(s,p+4,b[1],0); // filename
		fd=glh_fopen(p+4,"rb");
		if (!fd)
		{
			printf("[e] Cannot open file!! (%s) --"
					"strange thing :// ",p+4);
			glh_closeConnection(me,"Unable to load deps. check server data pool");
			return;
		}
		
		fseek(fd,0L,SEEK_END);
		i=fsize=ftell(fd);
			
		fseek(fd,0L,SEEK_SET);
		fsize=htonl(i);
		size=(char *)&fsize;
		send(s,size,4,0); // send file size
		size=(char *)malloc(i);
		fread(size,i,1,fd);
		if (cfg.v>1) printf("Size is : %d\n",i);

		for(	i2=i,n=i=0; i<i2; // Mad For Loop @_@
			i+=((i+cfg.bsize>i2)?i2-i:cfg.bsize),n++)
			{
			usleep(200);
			r=send(s,size+i,((i+cfg.bsize)>i2)?i2-i:cfg.bsize,0);
			if (r<1) 
				{
				printf("Sent error\n");
				glh_closeConnection(me,"Sent error");
				break;
				}
			}
		glh_fclose(fd);
		free(size);
		if (r<1) return;
		}

	// send next one or unlock client sync.
	printf("[d] Looking next dep...\n");

	// [CRC32][FILENAME\0] [...]
	client.p[me].pdep+=4;
		while(*(cfg.dep+client.p[me].pdep) &&
			  client.p[me].pdep < cfg.pdeps)
		{
			client.p[me].pdep++; // fins trobar un \0
		}
		client.p[me].pdep++; // anem al seguent crc.

		//printf("PRINTF %d %d\n",client.p[me].pdep,cfg.pdeps);
		if (client.p[me].pdep>=cfg.pdeps)
		{

		// s'han checkejat totes les dependencies.
		client.p[me].wait.ing=false;
		b[0]=PACKET_DEPS;
		glh_broadcast(-1,b,1);
		//send(client.p[me].sock,b,1,0);
		printf("[d] End of deps.\n");

		if (!client.p[me].onplay) // Si encara no esta en joc cal q s'esperi a les depsync per entrar-hi
		{
			char b[100];
			bool m=false;
			int i;

			// Lock deps for every player.
			printf("TRYING TO LOCK\n");
			pthread_mutex_lock(&cfg.deplock);
			printf("LOCKED :)\n");
			client.p[me].onplay=true;
			
			b[0]=PACKET_CHKF;
			for (i=0;i<client.n;i++)
			{
			if (i==me||!client.p[i].sock) continue;
			b[1]=strlen(cfg.dep+client.p[i].pdep+4); // no :/
			send(client.p[i].sock,b,2,0);
			send(client.p[i].sock,cfg.dep+client.p[i].pdep+4,b[1],0);// no :/
			}

			for(i=0;i<client.n;i++)
			{
				if (i==me||!client.p[i].sock) continue;
				client.p[i].wait.what=PACKET_CRCF;
				client.p[i].wait.ing=true;
			}
			printf ("[u] Updating global deps...\n");

			if (cfg.v>1) printf("Client %d waiting for Packe_OkOk.\n",me);
			client.p[me].wait.what=PACKET_OKOK;
			client.p[me].wait.ing=true;

			b[0]=PACKET_OKOK;              // Send an okok paquet
			send(client.p[me].sock,b,1,0);

			// Waiting for deps done.
			/*while(1)
				{
				int mm=0; // algun user guai?
				// Bucle mal fet!!!
				if (client.n==1) goto diend; // No deps to sync with one player
				if (cfg.v>0) printf("   son %d. waiting for depsdone...\n",me);

				for (i=0;i<client.n;i++)
					{
					printf("[#] %d/%d - me:%d (%d|%d)\n",i,client.n,me,client.p[i].wait.ing,
						client.p[i].wait.what);
					if (i==me||!client.p[i].sock) continue;
					mm++;
					if ((!client.p[i].wait.ing) && 
						(client.p[i].wait.what==PACKET_CRCF) ) 
						{
						printf("Orgasm Found\n");
						goto diend;
						}
					}
				if (!mm||i==client.n-1) break;
				sleep(1);
				}
			diend: */
			   // pthread_mutex_unlock(&client.p[i].lock); // 4ifTheFlies
				b[0]=PACKET_DEPS;
				glh_broadcast(-1,b,1);
			return;
			}
		}
		else
		{
		// creem un paquet CHECK_FILE...
			if (strlen(client.p[me].pdep+4+cfg.dep))
			{
			b[0]=PACKET_CHKF;
			b[1]=strlen(cfg.dep+client.p[me].pdep+4);
			send (s,b,2,0); // send header
			send (s,cfg.dep+client.p[me].pdep+4,b[1],0); // body.
			printf("   | FILE IS : \"%s\"\n",
			   client.p[me].pdep+4+cfg.dep, b[1]);
			}
		}
	return;
}

struct Shot { float x,y,z,vx,vy,vz; }; //packet contents.
void glh_readShot(int me)
{
	int i;

	Shot shot;
	char b[2];
	char *ptr=(char *)&shot;
	int  w=client.p[me].rpg.weapon;

    recv(client.p[me].sock,ptr,sizeof(Shot),0);

    if (! client.p[me].rpg.weapons[w].munition)
	{
		printf("Not enought ammo !!\n");
		return;
	}
	
	printf("Shot %f %f %f -> %f %f %f weapon:%d munition:%d range:%f\n",
		shot.x,shot.y,shot.z,shot.vx,shot.vy,shot.vz,
		w,  client.p[me].rpg.weapons[w].munition,  cfg.wp[w].range);

	b[0]=PACKET_SHOT;
	b[1]=(unsigned char)me;
	b[2]=(unsigned char)client.p[me].rpg.weapon;
	glh_broadcast(-1,b,3);

	// Check collision.
	for(i=0;i<client.n;i++)
	{
		float d;
		if (!client.p[i].sock||i==me) continue;
		d=getDistance(i,CVector3(shot.x,shot.y,shot.z),
			               CVector3(shot.vx,shot.vy,shot.vz));

		printf("Distance is %f %f\n",d,100*cfg.ratio); // gordo del tiw
		if (d < 100*cfg.ratio )
		{
			printf("Range: %f\n",cfg.wp[w].range*cfg.ratio*3);
			if ( Distance(
				CVector3(client.p[me].x,client.p[me].y,client.p[me].z),
				CVector3(client.p[i ].x,client.p[i ].y,client.p[i ].z))
				 < cfg.wp[w].range*cfg.ratio ) // Weapon range
			{
				srand(clock());
				// caldria q les armadures fossin utils xD
				printf("Rules %d\n",cfg.wp[w].damage);				
				client.p[i].rpg.mod[LIFE]-=(rand()%cfg.wp[w].damage);
				printf("Rules %d\n",client.p[i].rpg.mod[LIFE]);		
				
				if ((client.p[i].rpg.base[LIFE]+client.p[i].rpg.mod[LIFE])<=0)
				{
					printf ("Sxued!!\n");
					glh_userDead(i);
				}
				else
				{
					client.p[i].rpg.mod[LIFE]--;
					printf("AUUUCH %d\n",i);
					glh_sendRoleData(i);
				}
			}
		}
	}

	if ( cfg.wp[w].maxammo ) // if maxammo > 0
	{
		if (! (--client.p[me].rpg.weapons[w].munition) )
			 glh_readChwp(me);
	}
}

void glh_userDead(int me)
{
	int i=0;
	unsigned char b[300];

	printf("User is Dead!!\n");
	// Talk: User is dead
	b[0]=PACKET_TALK;
	b[1]=me;
	b[2]=strlen(" is dead.")+strlen(client.p[me].nick);
	sprintf((char *)b+3,"%s is dead.",client.p[me].nick);
	glh_broadcast(me,(char *)b,b[2]+2);
	
	// Regenerate RoleData
	for(i=0;i<MOD_MAX;i++) client.p[me].rpg.mod[i]=0;
	// Send't
	glh_sendRoleData(me);
	// SendBeginPoint
	glh_sendBeginPoint(me,-1);
}

struct Role {unsigned char life,ammo,sh_head,sh_body,strength,def,aim,speed;};
void glh_sendRoleData(int me)
{
	
	// vida, municio, armadura(cap,cos), fora, defensa, punteria, velocitat
	Role role;
	char *b=(char *)&role;
	char bu[1]={PACKET_ROLE};

	role.life=(unsigned char) 
				client.p[me].rpg.base[LIFE]+client.p[me].rpg.mod[LIFE];
	role.ammo=(unsigned char) 
				client.p[me].rpg.weapons[client.p[me].rpg.weapon].munition;
	role.sh_head=(unsigned char) 
				client.p[me].rpg.shield[HEAD];
	role.sh_body=(unsigned char)
				client.p[me].rpg.shield[BODY];
	role.strength=(unsigned char)
				client.p[me].rpg.base[STRENGTH]+client.p[me].rpg.mod[STRENGTH];
	role.def= (unsigned char)
				client.p[me].rpg.base[DEFENSE]+client.p[me].rpg.mod[DEFENSE];
	role.aim= (unsigned char)
				client.p[me].rpg.base[AIM]+client.p[me].rpg.mod[AIM];
	role.speed= (unsigned char)
				client.p[me].rpg.base[SPEED]+client.p[me].rpg.mod[SPEED];

	send(client.p[me].sock,bu,1,0);
    send(client.p[me].sock, b, sizeof(Role), 0);
}

void glh_broadcast(int me, char *b, int l)
{
	bool m;
	int i;
	for(i=0;i<client.n;i++)
	{
		if (client.p[i].onplay)  // Hyper Patch!
			if (client.p[i].wait.ing)
				if (client.p[i].wait.what==PACKET_CRCF)
					client.p[i].wait.ing=false;

	if(client.p[i].wait.ing)
		printf("%d is waiting for %d\n",i,client.p[i].wait.what);

		if(   client.p[i].sock     &&
		     !client.p[i].wait.ing &&
		      client.p[i].login       )
		{
		if ((me<0)||(i!=me)) m=true;
		else m=false;

		if (m)
			{
			if (me>=0)
			pthread_mutex_lock(&client.p[i].lock);
			send(client.p[i].sock,b,l,0);
			if (me>=0)
			pthread_mutex_unlock(&client.p[i].lock);
			}
		}
	}
}



