#include "client.h" 


int checkBounding(float x1, float y1, float z1,
		  float x2, float y2, float z2)
{
	float BOUND=10.0f*cfg.ratio;
	if (x1<x2) x2-=x1; else x2=x1-x2;
	if (y1<y2) y2-=y1; else y2=y1-y2;
	if (z1<z2) z2-=z1; else z2=z1-z2;

	if (x2<BOUND && y2<BOUND && z2<BOUND) return 1; // collision
	else return 0;                                  // all done :)
}

void *itemSleep(void *e)
{
	int i,me=(int)e;
	char b[3];

	sleep(cfg.itm[me].sleep); // wait a while
	printf("  o item %d wakes up!\n",me);
	cfg.itm[me].on=true;
	b[0]=PACKET_ITEM;
	b[1]=1; // enable item
	b[2]=me; // this item

	// BroadCast
	for(i=0;i<client.n;i++)
	{
		if (!client.p[me].sock) continue;
		pthread_mutex_lock(&client.p[i].lock);
		send(client.p[i].sock,b,3,0);
		pthread_mutex_unlock(&client.p[i].lock);
	}

	return 0;
}

void glh_doItemAction(int me,int n) // Who?, What item?
{
	char b[3];
	int s=client.p[me].sock,m=0,i,
	    w=cfg.itm[n].pkt[1]; // second item parameter.

	switch ( cfg.itm[n].pkt[0] )
	{
	case ITEM_WEAPON:
			if (!client.p[me].rpg.weapons[w].haveit)
			{
			// #_# Sure on that?
			client.p[me].rpg.weapon=w; // user change to this weapon
			client.p[me].rpg.weapons[w].haveit=true;
			client.p[me].rpg.weapons[w].munition =
				cfg.wp[w].ammo; // give base ammo
			b[0]=PACKET_WEAP; // give weapon data.
			memcpy(b+1,cfg.itm[n].pkt,2);
			send(s,b,3,0); // Send to user.
			} else {
			// #_# Give only half of the base ammo.??
			client.p[me].rpg.weapons[w].munition +=
				cfg.wp[w].ammo;
			}
			break;
	case ITEM_AMMO50: m+=25;
	case ITEM_AMMO25: m+=25;
			for(i=0;i<cfg.weaps;i++)
				if (cfg.wp[i].munition==w)
					if (client.p[me].rpg.weapons[i].haveit)
					{
						client.p[me].rpg.weapons[i].munition+=m;
						if (client.p[me].rpg.weapons[i].munition > cfg.wp[i].maxammo)
						{
							client.p[me].rpg.weapons[i].munition=cfg.wp[i].maxammo;
						}
					}
			break;
	case ITEM_LIFE:
			client.p[me].rpg.mod[LIFE]+=w;
			if (client.p[me].rpg.mod[LIFE]>0)
				client.p[me].rpg.mod[LIFE]=0;
			break;
	case ITEM_HEAD_SHIELD:
			if (w>client.p[me].rpg.mod[HEAD])
				client.p[me].rpg.mod[HEAD]=w;
			break;
	case ITEM_BODY_SHIELD:
			if (w>client.p[me].rpg.shield[BODY])
				client.p[me].rpg.shield[BODY]=w;
			break;
	case ITEM_LEGS_SHIELD:
			if (w>client.p[me].rpg.shield[LEGS])
				client.p[me].rpg.shield[LEGS]=w;
			break;
	case ITEM_TELETRANS:
			glh_sendBeginPoint(me,w);
			break;
	}
	
	return;
}

void glh_itemCollision(int me)
{
	float x=client.p[me].x,
	      y=client.p[me].y,
	      z=client.p[me].z;
	int   i;
	for(i=0;i<cfg.items;i++)
	{
	if (!cfg.itm[i].on) continue; // skip it.
	if (cfg.itm[i].pkt[0]!=ITEM_NOOP) //Isn't a NoOp packet
	if (checkBounding(x,y,z,
			  cfg.itm[i].x,
			  cfg.itm[i].y,
			  cfg.itm[i].z) )
		{
		char b[3];
		cfg.itm[i].on=false; //deactive item

		printf("ITEM PAWAH\n");

		b[0]=PACKET_ITEM;
		if (cfg.itm[me].sleep)
		{
		  b[1]=ITEM_HIDE; // hide item (must be a define in items.h)
		  b[2]=i; // what item to hide?
		  // Must do broadcast!! to remove this item.
		  glh_broadcast(me,b,3); 
		  // Info to this user
		  send(client.p[me].sock,b,3,0); //remove item
		  memcpy(b+1,cfg.itm[i].pkt,2);
		  // Spawn sleep thread
		  pthread_create(&cfg.itm[i].th, NULL,itemSleep,(void *)i);
		}
		// Check item DOH action
		glh_doItemAction(me,i);

		// Give item data to user.
 		memcpy(b+1,cfg.itm[i].pkt,2);
		send(client.p[me].sock,b,3,0);
		}
	}
}


