#include "main.h"

Client client;
ServerConf cfg;

int main(int argc, char *argv[])
{


	char   *err;
	int	conn_s;
	struct	sockaddr_in servaddr;
	#if WINDOWS
	WSADATA 	     wsa;
	WORD		     wVersionRequested;

	wVersionRequested = MAKEWORD( 2, 0 );
	if ( WSAStartup(wVersionRequested , &wsa) )
		errorHappened("Error starting","WSA");
	#endif

	printf("\nLoading networkh-server...\n");

	err=readConfiguration(CONFIG_FILE);
	if (err[0]) errorHappened("readConfiguration:",err);
	
	err=loadMap(cfg.map);
	if (err[0]) errorHappened("loadMap",err);

	createUniverse();

        if ( (cfg.s = socket(AF_INET, SOCK_STREAM, 0)) < 0 ) 
		errorHappened("Error creating","socket();");

	#if !WINDOWS
	setsockopt(cfg.s,SOL_SOCKET, SO_REUSEADDR,0,0);
	signal (SIGINT, closeGlhServer);  // catch interrupt signal.
	signal (SIGPIPE,SIG_IGN); // Catch SigPipe Signal. (4ifTheFlies;)
	#endif
	
        memset(&servaddr, 0, sizeof(servaddr));
        servaddr.sin_family      = AF_INET;
        servaddr.sin_addr.s_addr = htonl(INADDR_ANY);
        servaddr.sin_port        = htons(cfg.port);

	if ( bind(cfg.s, (struct sockaddr *) &servaddr, sizeof(servaddr)) < 0 )
		errorHappened("Cannot","bind();");

        if ( listen(cfg.s, 10) < 0 ) 
		errorHappened("Cannot","listen();");
	
	printf("    Listening on port %d.\n\n",cfg.port);

	client.n=0; // clients info is null at beggining.
	client.p=(Client_info *)malloc(1);
	if (!client.p) errorHappened("Error on malloc:","client.p");

    /** 	           **/
    /* main server loop */
    /** 	           **/

	if (cfg.login==LOGIN_OFFICIAL)
	{
		printf("Launching official KeepAlive thread...\n");
		pthread_create(&cfg.dbth, NULL, databaseWorker, 0);
	}

	while ( 1 )
	{
	
	if ( (conn_s = accept(cfg.s, NULL, NULL) ) < 1 ) 
		errorHappened("Error on ","accept");
	printf("[>] Connection accepted\n");
	getClient(conn_s);
	}

	delete cfg.db;
	return 0;
}

void *databaseWorker(void *arg)
{
	int i;
	while(!cfg.closing)
	{
		sleep(cfg.kaltime);
		for (i=0;i<client.n;i++)
		{
			if (client.p[i].sock)
			{
			cfg.db->sendKeepAlive(	client.p[i].nick,
						client.p[i].ID );
			}
		}
	}
}

void errorHappened(char *str,char *str2)
{
	printf("[E] %s %s.\n",str,str2);
	exit(1);
}

char *readConfiguration(const char *filename)
{
    FILE *fd;
    char buf[80];
   
    // Load standard configuration
    cfg.closing=0;
    cfg.maxconn=10;
    cfg.maxnick=10;
    cfg.port=9999;
    cfg.bsize=10240;
    cfg.kaltime=120;
    pthread_mutex_init(&cfg.lock,NULL);
    pthread_mutex_init(&cfg.deplock,NULL);
    cfg.login=LOGIN_ANONYMOUS; // by default no check passwords
    cfg.login_opt=(char *)malloc(2);
    strcpy(cfg.login_opt,"*");
    cfg.pdeps=0;
    cfg.dep=(char *)malloc(1);
    cfg.items=0;
    cfg.itm=(Items*)malloc(1);
    cfg.weaps=0;
    cfg.wp=(Weapons*)malloc(1);
    cfg.rooms=0;
    cfg.room=0;
    cfg.ratio=0.001f;
    cfg.hellomsg=(char *)malloc(1);
    cfg.hellomsg[0]=0;
    cfg.chNick=1;
	cfg.crcEnabled=0;


    printf("\n[i] Reading configuration\n");
    fd=fopen(filename,"r");
    if (!fd) errorHappened("Configuration file (config.svr)","not found");

    while(!feof(fd))
	{
	buf[0]=0;
	fscanf(fd,"%s",buf);
	if (buf[0]=='#') { fgets(buf,80,fd); continue; }
	if (!strncmp(buf,"PORT",4)) {
		fscanf(fd,"%s",buf);
		cfg.port=atoi(buf); }
	else
	if (!strncmp(buf,"KALTIME",7)) {
		fscanf(fd,"%s",buf);
		cfg.kaltime=atoi(buf); }
	else
	if (!strncmp(buf,"VERBOSE",7)) {
		fscanf(fd,"%d",&cfg.v); }
	else	
	if (!strncmp(buf,"MAXCONN",7)) {
		fscanf(fd,"%s",buf);
		cfg.maxconn=atoi(buf); }
	else
	if (!strcmp(buf,"HELLOMSG")) {
		fgets(buf,80,fd);
		cfg.hellomsg=(char *)realloc(cfg.hellomsg,strlen(buf)+1);
		buf[strlen(buf)-2]=0; // retrieve \n
		strcpy(cfg.hellomsg,buf); }
	else
	if (!strncmp(buf,"MAXNICK",7)) {
		fscanf(fd,"%s",buf);
		cfg.maxnick=atoi(buf); }
	else
	if (!strncmp(buf,"BUFFER",6)) {
		fscanf(fd,"%s",buf);
		cfg.bsize=atoi(buf); }
	else
	if (!strcmp(buf,"RATIO")) {
		fscanf(fd,"%f",&cfg.ratio); }
	else
	if (!strcmp(buf,"CHANGENICK")) {
		fscanf(fd,"%d",&cfg.chNick); }
	else
		if (!strcmp(buf,"CRC")) {
		fscanf(fd,"%d",&cfg.crcEnabled); }
	else
	if (!strcmp(buf,"MAP")) {
		fscanf(fd,"%s",buf);
		cfg.map=(char *)malloc(strlen(buf)+1);
		memcpy(cfg.map,buf,strlen(buf));
		cfg.map[strlen(buf)]=0; }
	else
	if (!strncmp(buf,"LOGIN",5)) {
		fscanf(fd,"%s",buf);
		if (!strncmp("anonymous",buf,9)) {
			FILE *fd;
			cfg.login=LOGIN_ANONYMOUS;
			cfg.login_opt=(char *)
				realloc(cfg.login_opt,strlen(buf+10)+1);
			strncpy (cfg.login_opt,buf+10,strlen(buf+10)-1);
			fd=fopen("default.rph","r"); // no access on w32 :/
			if (!fd)
			return "Cannot load default.rph for anonymous users";
			fclose(fd);
		} else
		if (!strncmp("official",buf,8)) {
			cfg.login=LOGIN_OFFICIAL;
			cfg.login_opt=(char *)
				realloc(cfg.login_opt,strlen(buf+19)+1);
			strncpy(cfg.login_opt,buf+7,strlen(buf+7)-1);
			*(cfg.login_opt+strlen(buf+7)-1)=0;
			cfg.db=new Database(cfg.login_opt,80);
			//return "official mode not supported\n";
		} else
		if (!strncmp("custom",buf,6)) {
			cfg.login=LOGIN_CUSTOM;
			cfg.login_opt=(char *)
				realloc(cfg.login_opt,strlen(buf+10)+1);
			strncpy(cfg.login_opt,buf+7,strlen(buf+7)-1);
			*(cfg.login_opt+strlen(buf+7)-1)=0;
			}
		}
	}
    fclose(fd);

    if (!cfg.hellomsg[0])
    {
	    cfg.hellomsg=(char *)realloc(cfg.hellomsg,strlen(HELLOMSG)+1);
	    strcpy(cfg.hellomsg,HELLOMSG);
    }

	printf(	"   [] configuration:\n"
		"    | login mode: %d\n"
		"    | login opts: \"%s\"\n"
		"    | max connections: %d\n"
		"    | kal time: %d\n"
		"    | port to use: %d\n"
		"    | Hello message: %s\n"
		"    | ChangeNick: %s\n"
		"    | world ratio: %f\n"
		"    | limit nick length: %d\n"
		"    | map file is: \"%s\"\n",
			cfg.login,
			cfg.login_opt,
		        cfg.maxconn,
			cfg.kaltime,
			cfg.port,
			cfg.hellomsg,
			(cfg.chNick)?"enabled":"disabled",
			cfg.ratio,
			cfg.maxnick,
			cfg.map);
	return "";
}

char *loadMap(char *filename)
{
	FILE *fd;
	int nitem,nweap; // item/weapon counter
	char **items=0, // char* item array
	     **weapons=0; // char *weapon array
	char *buf=0,
	     *file=0;
	int p=cfg.pdeps=0;
	int nSp=0; // n Start Points;

	cfg.items=0;
	buf=(char *)malloc(80);
	file=(char *)malloc(100);
	sprintf(file,"data/maps/%s",filename);
	printf("\n[i] Loading map...\n");

	addDep(&p,file); // first dep. is map filename.

	fd=fopen(file,"r");
	if (!fd) errorHappened("Cannot open map:",file);

	printf("[i] Loading default deps\n");

	// Load default weapon.
	addDep(&p,"data/weap/pistola.wph");
	addWeapon(&p,"data/weap/hand.wph",12.3f,45.6f,78.9f); // out of map :P (i hope xD)

	while(!feof(fd))
	{
		buf[0]=0;
		fscanf(fd,"%s",buf);
		if (!strcmp(buf,"TEXTURE"))
		{
			fscanf(fd,"%s",buf); fscanf(fd,"%s",buf);
			sprintf(file,"%s/%s",getDirs(buf),buf);
			addDep(&p,file); 
		} else
		if (!strcmp(buf,"PVS"))
		{
			fscanf(fd,"%s",buf);
			sprintf(file,"%s/%s",getDirs(buf),buf);
			addDep(&p,file);
		} else
		if (!strcmp(buf,"RATIO"))
		{
			fscanf(fd,"%f",&cfg.ratio);
		} else
		if (!strcmp(buf,"NUM_STARTS"))
		{
			fscanf(fd,"%d",&cfg.sp);
			if (!cfg.sp) continue;
			cfg.stp=(StartPoint*)malloc(cfg.sp * sizeof(StartPoint));
			printf("[i] Expecting %d begin points.\n",cfg.sp);
			nSp=0;
		} else
		if (!strcmp(buf,"START"))
		{
			if (cfg.sp==nSp) break;
			fscanf(fd,"%d",&cfg.stp[nSp].hab);
			fscanf(fd,"%f %f %f %f",
				&cfg.stp[nSp].x,
				&cfg.stp[nSp].y,
				&cfg.stp[nSp].z,
				&cfg.stp[nSp].r);

			cfg.stp[nSp].x*=cfg.ratio;
			cfg.stp[nSp].y*=cfg.ratio;
			cfg.stp[nSp].z*=cfg.ratio;
			
			printf("    StartPoint: %d %f %f %f %f (%d)\n", nSp,
				cfg.stp[nSp].x,
				cfg.stp[nSp].y,
				cfg.stp[nSp].z,
				cfg.stp[nSp].r,
				cfg.stp[nSp].hab);
			nSp++;
		} else
		if (!strcmp(buf,"NUMERO_ITEMS"))
		{
			fscanf(fd,"%d",&nitem);
			if (! nitem) continue;
			items=(char **)malloc(nitem*sizeof(char *));
			if (!items) return "Items malloc failed";
			nitem=0; //reset counter.
		} else
		if (!strcmp(buf,"NUMERO_WEAPONS"))
		{
			fscanf(fd,"%d",&nweap);
			if (!nweap) continue;
			weapons=(char **)malloc(nweap*sizeof(char *));
			if (!weapons) return "Weapons malloc failed";
			nweap=0; // reset counter.
		} else
		if (!strcmp(buf,"ITEM"))
		{
			int n=nitem-1;
			char file[50];
			fscanf(fd,"%s",buf);
			fscanf(fd,"%s",buf);
			sprintf(file,"%s/%s.ith","data/item",buf);
			items[nitem]=(char *)malloc(strlen(file)+1);
			if (!items) return "Items not initialized";
			strcpy(items[nitem],file);
			do {	if (n<0) break; // check his existence
				if(!strcmp(file,items[n]) )break;
			} while(--n>=0);
			if (n<0) if ( addDep(&p,file) ) exit(1);
			nitem++;
		} else
		if (!strcmp(buf,"WEAPON"))
		{
			int n=nweap-1;
			char file[100];
			
			fscanf(fd,"%s",buf);
			fscanf(fd,"%s",buf);
			sprintf(file,"%s/%s.wph","data/weap",buf);
			if (!weapons) return "Weapons not initialized";
			weapons[nweap]=(char *)malloc(strlen(file)+1);
			if (!weapons[nweap]) return "Weapon malloc failed";
			strcpy(weapons[nweap],file);
			do {	if (n<0) break; // check his existence
				if ( !strcmp(file,weapons[n]) ) break;
			} while(--n>=0);
			if (n<0) if ( addDep(&p,file) ) exit(1);      		
			nweap++;                     
		} else       
		if (!strcmp(buf,"ELEMENTO"))
		{
			fscanf(fd,"%s",buf);
			if (!strcmp(buf,"ITEM"))
			{
				float x,y,z;
				char model[100];
				int mmh;
				model[0]=0;
				fscanf(fd,"%d",&mmh);
				fscanf(fd,"%f %f %f",&x,&y,&z);
				x*=cfg.ratio;
				y*=cfg.ratio;
				z*=cfg.ratio;
				if(addItem(&p,items[mmh],x,y,z,(char *)&model))
					exit (1);
			} else
			if (!strcmp(buf,"WEAPON"))
			{
				float x,y,z;
				char model[50];
				int mmh;
				model[0]=0;
				fscanf(fd,"%d",&mmh);
				fscanf(fd,"%f %f %f",&x,&y,&z);
				x*=cfg.ratio;
				y*=cfg.ratio;
				z*=cfg.ratio;
				if (addWeapon(&p,weapons[mmh],x,y,z))
					exit(1);
			} 
		} else
		if (!strcmp(buf,"AUDIO"))
		{
			FILE *f=0;
			char b[100];

			fscanf(fd,"%s",buf);
			sprintf(b,"%s/%s",getDirs(buf),buf);
			printf ("Loading audio deps for this map...: %s\n",b);
			f=fopen(b,"r");
			if (!f)
			{
				printf("Cannot open audio deps for this map: %s\n",b);
				exit(1);
			}
			while(!feof(f))
			{
				buf[0]=0;
				fscanf(f,"%s",buf);
				if (!strcmp("AMBIENT_SOUND",buf)||
				    !strcmp("WALK",buf)         ||
				    !strcmp("RUN",buf)) 
				{
					buf[0]=0;
					fscanf(f,"%s",buf);
					sprintf(b,"%s/%s",getDirs(buf),buf);
					if (addDep(&p,b))
					{
						printf("Unable to add audio dep: %s\n",b);
						exit(1);
					}
				}
					
			}
			fclose(f);
		}
		if (!strcmp(buf,"NUMERO_HABITACIONES"))
		{
			fscanf(fd,"%d",&cfg.rooms);
			if (!cfg.rooms) return "0 rooms?!?!?";
			cfg.room=(Room *)malloc(cfg.rooms*sizeof(Room));
			if (!cfg.room)
			{
			printf("Failed to alocate %d rooms\n",cfg.rooms);
			}
			printf("[i] Loading %d rooms.\n",cfg.rooms);
		} else
		if (!strcmp(buf,"HABITACION"))
		{
			int hab,n,i;
			bool mmh=true;
			int portals=0;

			fscanf(fd,"%d",&hab);
			printf("     LOADING ROOM %d\n",hab);
			if (hab>cfg.rooms)
			{
			printf("INVALID MPH file (trying to load a"
				" room without know how many are)\n");
			}
			cfg.room[hab].portals=0;
			cfg.room[hab].nfc=0;
			while(mmh&&!feof(fd))
			{
				buf[0]=0;
				fscanf(fd,"%s",buf);
			if (!strcmp(buf,"NUM_PORTALS"))
				{
				fscanf(fd,"%d",&n);
				if (!n) continue;
				cfg.room[hab].portals=n;
				cfg.room[hab].port=
					(Portal *)malloc(n*sizeof(Portal));
				cfg.room[hab].pointsto=
					(int *)malloc(n*sizeof(int));
				if (cfg.v>0) printf("    - Portals: %d\n",n);
				portals=0;
				} else
			if (!strcmp(buf,"ELEMENTO"))
				{
				fscanf(fd,"%s",buf);
				if (!strcmp(buf,"PORTAL")) // Portal data
					{
					fscanf(fd,"%d",&n);
					if (cfg.v>1) 
					printf( "     * Loading a portal %d points to "
						"room %d\n",portals,n+1);
					cfg.room[hab].pointsto[portals]=n;
					n--;
					for(i=0;i<4;i++)
						{
						fscanf(fd,"%f %f %f",
							&cfg.room[hab].port[portals].x[i],
							&cfg.room[hab].port[portals].y[i],
							&cfg.room[hab].port[portals].z[i] );
						cfg.room[hab].port[portals].x[i]*=cfg.ratio;
						cfg.room[hab].port[portals].y[i]*=cfg.ratio;
						cfg.room[hab].port[portals].z[i]*=cfg.ratio;
						}
					portals++;
					} else
					// Room vertex array
				if (!strcmp(buf,"HAB"))
				{
					float *vtx=0,*vtxo=0;
					int nvx=0; // n vertex.
					int *fcs=0;
					int nfc=0;

						fscanf(fd,"%s",buf);
						if (!strcmp(buf,"NUM_VERTEX"))
						{
							fscanf(fd,"%d",&nvx);
							if (!nvx) return "Numvertex 0???";
							if (cfg.v>1) printf("Num Vertex in room: %d\n",nvx);
							vtx=(float *)malloc(sizeof(float)*nvx*3);
							if (!vtx)
							{
								printf("Error allocating %d vertex\n",nvx);
								exit(1);
							}
							for (i=0;i<nvx*3;i+=3)
							{
								int j=0;
								fscanf(fd,"%f %f %f",
									&vtx[i+0], &vtx[i+1], &vtx[i+2]);
								for(j=0;j<3;j++)
								   vtx[i+j]*=cfg.ratio;

								//printf("-> %f %f %f\n",vtx[i],vtx[i+1],vtx[i+2]);
							}

							
						} 
						fscanf(fd,"%s",buf);
						if (!strcmp(buf,"NUM_FACES"))
						{
							int tmp;
							if (!nvx)
							{
								printf("Undefined num faces\n");
								exit(1);
							}

							fscanf(fd,"%d",&nfc);
							if (!nfc) return "0 faces?!?";
							fcs=(int *)malloc(sizeof(int)*nfc*3);
							
							for(i=0;i<nfc*3;i+=3) // face2face
							{
								int j=0;
								fscanf(fd,"%d %d %d %d",
									&fcs[i+0],&fcs[i+1],&fcs[i+2],&tmp);
							}

							// Reordening rules
							cfg.room[hab].nfc=nfc;
							cfg.room[hab].vtx=(float *)malloc(sizeof(float)*nfc*9);
							for (i=0;i<nfc*3;i++)
							{
								cfg.room[hab].vtx[(i*3)+0] = vtx[ (fcs[i]*3)+0 ];
								cfg.room[hab].vtx[(i*3)+1] = vtx[ (fcs[i]*3)+1 ];
								cfg.room[hab].vtx[(i*3)+2] = vtx[ (fcs[i]*3)+2 ];
								
								}

						
							


													
							if (cfg.v>1) printf("VERTEX ORDENED\n");
						} else {
							printf("SUX\n");
							exit(1);
						}

						if (vtx) free(vtx);
						if (vtxo) free(vtxo);
						if (fcs) free(fcs);
						hab++;
					}
				}
			}
		}
	}
	cfg.pdeps=p;
	if (!nSp)
	{
		printf("No begin points defined in this map.\n");
		exit(1);
	}
	
	printf("\n[+] Main deps done...\n");
	
	fclose(fd);
	free(buf);
	free(file);
	return "";
}

int _addItem(float x, float y, float z, int sleep, char doh, char action)
{
	cfg.items++;
	cfg.itm=(Items *)
		realloc(cfg.itm,cfg.items*sizeof(Items));
	if (!cfg.itm) return 1;

	cfg.itm[cfg.items-1].x=x;
	cfg.itm[cfg.items-1].y=y;
	cfg.itm[cfg.items-1].z=z;
	cfg.itm[cfg.items-1].on=true;
	cfg.itm[cfg.items-1].sleep=sleep;
	cfg.itm[cfg.items-1].pkt[0]=doh;
	cfg.itm[cfg.items-1].pkt[1]=action;
	
	printf("    Added item (%f %f %f), sleep %d action %d %d\n",x,y,z,sleep,doh,action);
	return 0;
}

		
int addItem(int *p, char *file, float x, float y, float z,char *model)
{
	FILE *fd;
	int sleep=10; // default sleep time.
	int pkt[2]={-1,-1};
	char pkt2[2];
	char buf[100];

	model[0]=0;
	// Read itm data
	fd=fopen(file,"r"); // read item data.
	if(!fd) {
		printf("[E] Unable to open %s item\n",file);
		exit(1);
	}
	while(!feof(fd))
	{
		buf[0]=0;
		fscanf(fd,"%s",buf);
		if (!strcmp(buf,"SLEEP")) {
			fscanf(fd,"%d",&sleep);	
		} else
		if (!strcmp(buf,"DO")) {
			fscanf(fd,"%d %d",&pkt[0],&pkt[1]);
		} else
		if (!strcmp(buf,"MODEL")) {
			fscanf(fd,"%s",buf);
			sprintf(model,"%s/%s",getDirs(buf),buf);
			if (addDep(p,model))
				exit(1);
		}
	}
	fclose(fd);

	if (pkt[0]<0) {
		printf("Item %d have no action defined\n",cfg.items);
		exit(1);
	}
	if (!model[0]) {
		printf("Item %d have no model defined\n",cfg.items);
		exit(1);
	}


	// Add new item
	pkt2[0]=pkt[0];pkt2[1]=pkt[1];
	return _addItem(x,y,z,sleep,pkt[0],pkt[1]);
}

int addWeapon(int *p, char *f,float x, float y, float z)
{
	FILE *fd;
	char buf[100];
	int damage=0, // default values
	    sleep=10,
	    ammo=0,
	    maxammo=0,
	    type=0;
	float range;
	char model1[50], // just one more dep
	     model3[50]; // item model

	fd=fopen(f,"r");
	if (!fd) errorHappened("Unable to open weapon",f);

	while(!feof(fd))
	{
		buf[0]=0;
		fscanf(fd,"%s",buf);
		if (!strcmp(buf,"DAMAGE")) {
			fscanf(fd,"%d",&damage); 
		} else
		if (!strcmp(buf,"SLEEP")) {
			fscanf(fd,"%d",&sleep);
		} else
		if (!strcmp(buf,"AMMO")) {
			fscanf(fd,"%d",&ammo);
		} else
		if (!strcmp(buf,"MAXAMMO")) {
			fscanf(fd,"%d",&maxammo);
		} else
		if (!strcmp(buf,"RANGE")) {
			fscanf(fd,"%f",&range);
		} else
		if (!strcmp(buf,"MODEL1")) {
			fscanf(fd,"%s",model1);
		} else
		if (!strcmp(buf,"MODEL3")) {
			fscanf(fd,"%s",model3);
		} else
		if (!strcmp(buf,"TYPE")) {
			fscanf(fd,"%d",&type);
		} 
	}
	fclose(fd);

	// Add weapon data
	cfg.weaps++;
	cfg.wp=(Weapons *)
		realloc(cfg.wp,cfg.weaps*sizeof(Weapons));
	cfg.wp[cfg.weaps-1].damage=damage;
	cfg.wp[cfg.weaps-1].ammo=ammo;
	cfg.wp[cfg.weaps-1].range=range;
	cfg.wp[cfg.weaps-1].type=type;
	printf("    Added weapon (%d %d) - range : %f\n",damage,ammo,range);

	if (x==12.3 && y==45.6 && z==78.9) return 0; // magic data :D

	// Add weapon as item data
	return _addItem(x,y,z,sleep,ITEM_WEAPON,cfg.weaps-1);
}

int addDep(int *p,char *f) // pointer to depstring && filename
{
	FILE *fd;
	int fsize,l,d=4;
	char *b=0,bf[2];
	unsigned int crc;

	if (!p||!f)
	{
		printf("[x] NULL Pointer on addDep. returning.");
		return 1;
	};

	for(l=strlen(f);f[l-1]!='/';l--);

	fd=fopen(f,"r");
	if(!fd)
	{
		printf("[E] Unable to load dep %s - check server data.\n",f);
		return 1;
	}

	pthread_mutex_lock(&cfg.lock);
	// check if it is added
	while(1)
	{
		if (d>=cfg.pdeps||!strlen(cfg.dep+d))      // deps done
			break;
		if (!strcmp(f+l,cfg.dep+d)) 
		{ 
			if (cfg.v>1) printf("    - Dep collision %s\n",f);
			pthread_mutex_unlock(&cfg.lock);
			return 0; 
		}
		d+=strlen(cfg.dep+d)+1+4;
	}
	fseek(fd,0L,SEEK_END);
	fsize=ftell(fd);
	if (fsize) 
	{
		fseek(fd,0L,SEEK_SET);
	    b=(char *)malloc(fsize*sizeof(char));
		fread(b,fsize,1,fd);
		crc=htonl(crc32(b,fsize));
	    free(b);
	} else
	crc=0;
	
	b=(char *)&crc;
	cfg.pdeps+=CRC_SIZE+strlen(f)+1;
	cfg.dep=(char *)realloc(cfg.dep, cfg.pdeps);
	if (!cfg.dep) errorHappened("Realloc error on","cfg.dep");

	memcpy( cfg.dep + *p, b,4); // copiem el crc32
	memcpy( cfg.dep + *p + 4, f+l, strlen(f+l)+1); // copiem l'string
	fclose(fd);
	pthread_mutex_unlock(&cfg.lock);

	printf("    Added: [%2x:%2x:%2x:%2x] (%s) size %d\n",
		(unsigned char)b[0],
		(unsigned char)b[1],
		(unsigned char)b[2],
		(unsigned char)b[3],f,fsize);

	*p+=CRC_SIZE+strlen(f+l)+1;

//	if (client.n) printf("########### %x VS %x #############\n",client.p[0].pdep,cfg.pdeps);
	return 0;

	if (client.p[0].pdep)
	{
		client.p[0].wait.ing=true;
		client.p[0].wait.what=PACKET_CRCF;
		bf[0]=PACKET_CHKF;
		bf[1]=strlen(cfg.dep+client.p[0].pdep);
		if (bf[1]<3) return 0; // Ungly patch xD
		send(client.p[0].sock,bf,2,0);
		send(client.p[0].sock,cfg.dep+client.p[0].pdep+4,bf[1],0);
		printf("   | Checking realtime dep.\n");
	}

	return 0;
}


void closeGlhServer(int signal)
{
	int i;
	
	if (cfg.closing)
	{
		printf("[-] Don't panic! I'm working for you ;)\n");
		return;
	}
	cfg.closing=1;
	close(cfg.s);
	printf("[-] Signal catched!\n");
	for (i=0;i<client.n;i++)
		if (client.p[i].sock)
		{
			printf("    Socket %d closed.\n",i);
			glh_closeConnection(i,"Control-C");
		}
	printf("[-] All connections closed.\n");
	for(i=0;i<client.n;i++)
	{
		if (!client.p[i].sock) continue;
		pthread_join(client.p[i].thread,NULL);
	}
	if (cfg.login==LOGIN_OFFICIAL)
	{
		printf("[-] Joining Database thread...");
		pthread_join(cfg.dbth,NULL);
	}
	printf("[-] All threads joined.\n");
	close(cfg.s);
	exit(0);
}


