#include "universe.h"

void exitEntity(int me)
{
#if COLLISION
	cfg.pUnivers->DeleteEntity(0,me);
#endif
}





void loadEntity(int me)
{
#if COLLISION
	cols::IBounding* pBoundEntitat = cols::g_pBoundingFactory->CreateSphere(
		ODvector3(0,0,0), client.p[me].heights.knee );
	cfg.pUnivers->CreateEntity( 0, me, pBoundEntitat );
#endif
}





void createUniverse()
{
int i,j;
float xm,ym,zm,xM,yM,zM;

#if COLLISION
cfg.pUnivers = cols::g_pCollisions->CreateUniverse( 0 );

cfg.pUnivers->CreateSubspace( 0 );


for (i=0;i<cfg.rooms;i++)
	{
	printf("Processing room: %d\n",i);
		xM=xm=cfg.room[i].vtx[0];
		yM=ym=cfg.room[i].vtx[1];
		zM=zm=cfg.room[i].vtx[2];

	for (j=0; j<cfg.room[i].nfc*3; j++)
	{
		// maxims
		if (cfg.room[i].vtx[(j*3)+0]>xM) xM=cfg.room[i].vtx[(j*3)+0];
		if (cfg.room[i].vtx[(j*3)+1]>yM) yM=cfg.room[i].vtx[(j*3)+1];
		if (cfg.room[i].vtx[(j*3)+2]>zM) zM=cfg.room[i].vtx[(j*3)+2];
		// mnims
		if (cfg.room[i].vtx[(j*3)+0]<xm) xm=cfg.room[i].vtx[(j*3)+0];
		if (cfg.room[i].vtx[(j*3)+1]<ym) ym=cfg.room[i].vtx[(j*3)+1];
		if (cfg.room[i].vtx[(j*3)+2]<zm) zm=cfg.room[i].vtx[(j*3)+2];
	}

	printf("Boundings are: [%f|%f|%f] [%f|%f|%f]\n",  xm,ym,zm,xM,yM,zM);


	// Crea les rees
	cols::IBounding* pBoundArea = cols::g_pBoundingFactory->CreateAlignedBox(
		ODvector3(xm,ym,zm), ODvector3(xM,yM,zM) );
	cfg.pUnivers->CreateArea( i, pBoundArea );

	/*
	for (j=0;j<cfg.room[i].nfc*3;j+=9) // face 2 face
	{
		cols::IBounding* pBoundEntitat = cols::g_pBoundingFactory->CreatePolygon
			(
			ODvector3(
				cfg.room[i].vtx[(j*3)+0],
				cfg.room[i].vtx[(j*3)+1],
				cfg.room[i].vtx[(j*3)+2]),
			ODvector3(
				cfg.room[i].vtx[(j*3)+3],
				cfg.room[i].vtx[(j*3)+4],
				cfg.room[i].vtx[(j*3)+5]),
			ODvector3(
				cfg.room[i].vtx[(j*3)+6],
				cfg.room[i].vtx[(j*3)+7],
				cfg.room[i].vtx[(j*3)+8])
			);
		cfg.pUnivers->CreateEntity( 0,-j, pBoundEntitat ); // REVISAR J!!! x)
		
	}
	*/


}
#endif

}




float getDistance(int me,CVector3 o,CVector3 d)
{
	CVector3 human( client.p[me].x,
		            client.p[me].y + client.p[me].heights.head,
					client.p[me].z );

	CVector3 bullet = ClosestPointOnLine (o, o+(d*100), human);
	printf ("me: %d\no: %f %f %f\nd: %f %f %f\nh: %f %f %f\nb: %f %f %f\n",
		me,o.x,o.y,o.z,d.x,d.y,d.z,human.x,human.y,human.z,bullet.x,bullet.y,bullet.z);
	return Distance(human, bullet);
}


//=====================================================
// 
// Maths (c&p mode)
//
//=====================================================

float Magnitude(CVector3 vNormal)
{

	return (float)sqrt( (vNormal.x * vNormal.x) + 
				(vNormal.y * vNormal.y) + 
				(vNormal.z * vNormal.z) );
}
CVector3 Normalize(CVector3 vNormal)
{
	float magnitude = Magnitude(vNormal);				// Get the magnitude of our normal

	vNormal.x /= magnitude;	
	vNormal.y /= magnitude;	
	vNormal.z /= magnitude;	

	return vNormal;										// Return the new normal of length 1.
}

float Dot(CVector3 vVector1, CVector3 vVector2) 
{
	return ( (vVector1.x * vVector2.x) + (vVector1.y * vVector2.y) + (vVector1.z * vVector2.z) );
}

float Distance(CVector3 vPoint1, CVector3 vPoint2)
{
	double distance = sqrt( (vPoint2.x - vPoint1.x) * (vPoint2.x - vPoint1.x) +
						    (vPoint2.y - vPoint1.y) * (vPoint2.y - vPoint1.y) +
						    (vPoint2.z - vPoint1.z) * (vPoint2.z - vPoint1.z) );


	return (float)distance;
}

CVector3 ClosestPointOnLine(CVector3 vA, CVector3 vB, CVector3 vPoint)
{
	CVector3 vVector1 = vPoint - vA;
    CVector3 vVector2 = Normalize(vB - vA);
    float d = Distance(vA, vB);
    float t = Dot(vVector2, vVector1);
    if (t <= 0) return vA;
    if (t >= d) return vB;
    CVector3 vVector3 = vVector2 * t;
    CVector3 vClosestPoint = vA + vVector3;
	return vClosestPoint;
}
