#ifndef _INCLUDE_UNIVERSE_H_
#define _INCLUDE_UNIVERSE_H_
#include "main.h"
#include <math.h>


void createUniverse();
void loadEntity(int me);
void exitEntity(int me);


//=====================================================
// 
// Maths (c&p mode)
//
//=====================================================

#define PI 3.1415926535897932					// This is our famous PI

struct CVector3
{
public:
	CVector3() {}
	CVector3(float X, float Y, float Z) 
		{ x = X; y = Y; z = Z;	}
	CVector3 operator+(CVector3 vVector)
		{ return CVector3(vVector.x + x, vVector.y + y, vVector.z + z);	}
	CVector3 operator-(CVector3 vVector)
		{ return CVector3(x - vVector.x, y - vVector.y, z - vVector.z);	}
	CVector3 operator*(float num)
		{ return CVector3(x * num, y * num, z * num); }
	float x, y, z;						
};


float Magnitude(CVector3 vNormal);
CVector3 Normalize(CVector3 vNormal);
float Dot(CVector3 vVector1, CVector3 vVector2);
float Distance(CVector3 vPoint1, CVector3 vPoint2);
CVector3 ClosestPointOnLine(CVector3 vA, CVector3 vB, CVector3 vPoint);



// MY code again

float getDistance(int who,CVector3 o,CVector3 d);

#endif

